//=============================================================================
// TOSP_Intro.
//=============================================================================
// The Intro gametype for the TOSP intro map.
//=============================================================================
// Programmed by Mathieu 'EMH_Mark3' Mallet for Tactical Ops
// 06/07/2002
//=============================================================================

class TOSP_IntroHUD extends TO_IntroHUD;

var bool bOpenedWindow;

///////////////////////////////////////
// Tick
///////////////////////////////////////

function Tick(float Delta)
{
	LogoTiming += Delta;

	if ( (LogoTiming > 0.0) && (LogoTiming < 4.0) )
	{
		if ( LogoFadeTime < 1.0 )
		{
			LogoFadeTime += Delta/1.5;
			if ( LogoFadeTime > 1.0 )
				LogoFadeTime = 1.0;
		}
	}
	else if ( CurrentLogo != L_TOAoT )
	{
		if ( LogoFadeTime > 0.0 )
		{
			LogoFadeTime -= Delta/1.5;
			if ( LogoFadeTime < 0.0 )
			{
				LogoFadeTime = 0.0;
				if ( CurrentLogo == L_MP )
				{
					LogoTiming = 0.0;
					CurrentLogo = L_KS;
				}
				else if ( CurrentLogo == L_KS )
				{
					CurrentLogo = L_TOAoT;
					LogoTiming = 0.0;
				}
				//if ( CurrentLogo == L_TOAoT )
			}
		}
	}

	if ( (Level!=None) )
	{
		if ( !bLaunchMenu && (PlayerOwner!=None) && (PlayerOwner.Player!=None) && (PlayerOwner.Player.console!=None)
			&& (TournamentConsole(PlayerOwner.Player.console)!=None) )
		{
			// Launch UWindow
			TournamentConsole(PlayerOwner.Player.console).LaunchUWindow();
			bLaunchMenu = true;
			TournamentConsole(PlayerOwner.Player.console).bNoDrawWorld = false;
		}
		if (bLaunchMenu && !bOpenedWindow && TournamentConsole(PlayerOwner.Player.console).Root != none) {
			bOpenedWindow = true;
			log("about to create window...");
			TournamentConsole(PlayerOwner.Player.console).Root.CreateWindow(class<UMenuBotmatchWindow>(DynamicLoadObject("TO_SinglePlayer.TO_StartSinglePlayerSC", class'Class')), 100, 100, 200, 200, , true);
			log("window created.");
		}

		//ESCFadeTime += Delta / 4;
		//if ( ESCFadeTime > 1.0 )
		//	ESCFadeTime = 1.0;
	}
}
