//=============================================================================
// TO_PaintBall.
//=============================================================================
// Removes blood and replaces bullet hits by paint.
//=============================================================================
// Programmed by Mathieu 'EMH_Mark3' Mallet for Tactical Ops
// 07/12/2002
//=============================================================================

class TO_PaintBall expands Mutator;

#exec TEXTURE IMPORT NAME=to_sp_paintsplash1	FILE=Textures\Decals\PaintSplash1.pcx		GROUP="Decals" LODSET=2
#exec TEXTURE IMPORT NAME=to_sp_paintsplash2	FILE=Textures\Decals\PaintSplash2.pcx		GROUP="Decals" LODSET=2
#exec TEXTURE IMPORT NAME=to_sp_paintsplash3	FILE=Textures\Decals\PaintSplash3.pcx		GROUP="Decals" LODSET=2
#exec TEXTURE IMPORT NAME=to_sp_paintsplash4	FILE=Textures\Decals\PaintSplash4.pcx		GROUP="Decals" LODSET=2
#exec TEXTURE IMPORT NAME=to_sp_paintsplash5	FILE=Textures\Decals\PaintSplash5.pcx		GROUP="Decals" LODSET=2
#exec TEXTURE IMPORT NAME=to_sp_paintsplash6	FILE=Textures\Decals\PaintSplash6.pcx		GROUP="Decals" LODSET=2
#exec TEXTURE IMPORT NAME=to_sp_paintsplash7	FILE=Textures\Decals\PaintSplash7.pcx		GROUP="Decals" LODSET=2
#exec TEXTURE IMPORT NAME=to_sp_paintsplash8	FILE=Textures\Decals\PaintSplash8.pcx		GROUP="Decals" LODSET=2
#exec TEXTURE IMPORT NAME=to_sp_paintsplash9	FILE=Textures\Decals\PaintSplash9.pcx		GROUP="Decals" LODSET=2
#exec TEXTURE IMPORT NAME=to_sp_paintsplash10	FILE=Textures\Decals\PaintSplash10.pcx		GROUP="Decals" LODSET=2

var	string	Textures[16];
var int		NumTextures;

function prebeginplay() {
	// precache the stuff
	PrecacheStuff();

	spawn(class'TO_SinglePlayer.TO_PaintBallSpawnNotify');
}

static function Texture GetRandomTexture() {
	return Texture(DynamicLoadObject(default.Textures[rand(default.NumTextures)],class'Texture'));
}

function PrecacheStuff() {
	local int i;
	local Texture	texture;
	local sound		sound;

	sound = Sound(DynamicLoadObject("UnrealShare.BioRifle.GelHit",class'Sound'));
	
	for (i = 0; i < NumTextures; i++)
		texture = Texture(DynamicLoadObject(Textures[i], class'Texture'));
}

defaultproperties
{
     Textures(0)="TO_SinglePlayer.to_sp_paintsplash1"
     Textures(1)="TO_SinglePlayer.to_sp_paintsplash2"
     Textures(2)="TO_SinglePlayer.to_sp_paintsplash3"
     Textures(3)="TO_SinglePlayer.to_sp_paintsplash4"
     Textures(4)="TO_SinglePlayer.to_sp_paintsplash5"
     Textures(5)="TO_SinglePlayer.to_sp_paintsplash6"
     Textures(6)="TO_SinglePlayer.to_sp_paintsplash7"
     Textures(7)="TO_SinglePlayer.to_sp_paintsplash8"
     Textures(8)="TO_SinglePlayer.to_sp_paintsplash9"
     Textures(9)="TO_SinglePlayer.to_sp_paintsplash10"
     NumTextures=10
}
