//=============================================================================
// TO_SPHCB_HostageRescuePlusAny.
//=============================================================================
// Modified hostage rescue scenario -- SWAT only have to rescue one of the
// three hostages (doesn't matter which one)
//=============================================================================
// Programmed by Mathieu 'EMH_Mark3' Mallet for Tactical Ops
// 14/11/2002
//=============================================================================

class TO_SPHCB_HostageRescuePlusAny expands TO_SPHCB_HostageRescuePlus;

var bool		bFirstExitTriggerCheck;

function PostRestartRound() {
	super.PostRestartRound();

	bFirstExitTriggerCheck = true;
}

function CheckIfExitTriggerShouldBeSpawned() {
	if (game.nbRescuedHostages > 0 && bFirstExitTriggerCheck) {
		bFirstExitTriggerCheck = false;
		game.bEndGameTriggersSpawned = false;
		game.SpawnEndGameTriggers();
		game.SpecialTriggersMSG();
	}
}

function HostageKilled(pawn killer, pawn Other, name damageType) {
	if (game.nbHostagesLeft < 2) {	// nbHostagesLeft is decremented AFTER HostageKilled is called
		game.SetWinner(0);
		game.BroadcastLocalizedMessage(class'TO_SP_Messages', 1);
		game.EndGame(class'TO_SP_Messages'.default.WinMessage[1]);
	}
}

defaultproperties
{
     bFirstExitTriggerCheck=True
}
