//=============================================================================
// TO_SPHCB_MultipleC4Mission.
//=============================================================================
// Special mission behaviors.
// Usage of this allows multiple C4 to be used in the same round.
// Coded for Desperado's map.
//=============================================================================
// Programmed by Mathieu 'EMH_Mark3' Mallet for Tactical Ops
// 19/08/2002
//=============================================================================

class TO_SPHCB_MultipleC4Mission expands TO_SP_HardCodedBehaviors;

var	TO_SinglePlayerGame		game;

function Initialise(TO_SinglePlayerGame myGame) {
	game = myGame;
	game.bUseMultipleC4 = true;		// Signal the game to allow multiple c4 explosions
}

function PreRestartRound() {
	local s_C4		c4;
	
	foreach allactors(class's_SWAT.s_C4', c4)		// Delete the extra c4 in the level
		c4.Destroy();
	
}

function PostRestartRound() { }

function C4Planted(vector PlantLocation, s_ExplosiveC4 PlantedC4) {
	local TO_SP_BombingPoint		B;
	local s_ExplosiveC4				C4;

	foreach AllActors(class'TO_SP_BombingPoint', B) {
		//log("TO_SPHCB_MultipleC4Mission::C4Planted: Checking bomb spot B.name = " $ string(B.name));
		foreach VisibleCollidingActors(class's_ExplosiveC4', C4, sqrt(B.CollisionRadius * B.CollisionRadius + B.CollisionHeight * B.CollisionHeight) + 5, B.Location) {
			//log("TO_SPHCB_MultipleC4Mission::C4Planted: Found matching bombing spot! B.name = " $ string(B.name));
			B.DisableBombSpot();	// Disallow further bomb placement here
			if (B.C4CountdownTime != 0) {
				PlantedC4.Countdown = B.C4CountdownTime;
				//PlantedC4.MaxCount = ( PlantedC4.Countdown / 3) - 0.7;
				PlantedC4.MaxCount = ( PlantedC4.Countdown / 3);
			}
		}
	}



}

function bool PickupQuery( Pawn Other, Inventory item, out int bUseDefault ) {
	local actor C4Link;

	// By default, use the default pickupquery function
	bUseDefault = 1; // true

	// Prevent player from picking up more than one c4
	if ( Other.PlayerReplicationInfo != None ) {
		if ( item.IsA('TO_SP_C4') && (Other.PlayerReplicationInfo.Team == 0) ) {
			C4Link = none;
			C4Link = Other.FindInventoryType(class'TO_SP_C4');
			if (C4Link != none) {
				bUseDefault = 0; // false
				return false;
			}
		}
	}
}

defaultproperties
{
}
