//=============================================================================
// TO_SPStringDecoder.
//=============================================================================
// This class decodes a string of the form:
//   MyNames="Pathnode1,Pathnode2,Pathnode3"
// into:
//   MyName1="Pathnode1", MyName2="Pathnode2", MyName3="Pathnode3"
//=============================================================================
// Programmed by Mathieu 'EMH_Mark3' Mallet for Tactical Ops
// 19/08/2002
//=============================================================================

class TO_SPStringDecoder expands Info;

var string	names[63];
var string	strings[63];
var	float	radiuses[63];
var float	heights[63];	

function decodeStrings(string encodedNames, string encodedStrings) {
	local int		currentArrayPosition;
	local int		i;

	local int		currentPosNames;
	local string	remainingNames;
	local string    currentName;
	
	local int		currentPosStrings;
	local string	remainingStrings;
	local string	currentString;

	currentArrayPosition = 0;

	if (right(encodedNames,1) == " ")
		remainingNames = left(encodedNames,len(encodedNames)-1) $ ",";
	else
		remainingNames = encodedNames $ ",";

	if (right(encodedNames,1) == " ")
		remainingStrings = left(encodedStrings,len(encodedStrings)-1) $ ",";
	else
		remainingStrings = encodedStrings $ ",";

	for (i = 0; i < 63; i++) {
		names[i]="None";
		//strings[i]="**NAME NOT FOUND " $ i $ " **";
	}

	if (remainingNames == ",")
		return;

	while (instr(remainingNames, ",") != -1) {
		currentPosNames   = instr(remainingNames, ",");
		currentPosStrings = instr(remainingStrings, ",");

		currentName		= left(remainingNames, currentPosNames);
		currentString	= left(remainingStrings, currentPosStrings);

		remainingNames	= mid(remainingNames, currentPosNames + 1);
		remainingStrings = mid(remainingStrings, currentPosStrings + 1);

		if (currentPosStrings == -1) {
			warn("TO_SPStringDecoder::decodeStrings: Number of elements in strings do not match for '" $ encodedNames $ "' and '" $ encodedStrings $ "'.");
			//currentString = "**NO MATCHING STRING**";
		}

		names[currentArrayPosition] = currentName;
		strings[currentArrayPosition] = currentString;

		currentArrayPosition++;

		if (currentArrayPosition == 63) {
			warn("TO_SPStringDecoder::decodeStrings: Too many elements in list: '" $ encodedNames $ "'.");
			assert(false);
		}

	}


}

function decodeStringAndFloats(string encodedNames, string encodedRadiuses, string encodedHeights) {
	local int		currentArrayPosition;
	local int		i;

	local int		currentPosNames;
	local string	remainingNames;
	local string    currentName;
	
	local int		currentPosRadiuses;
	local string	remainingRadiuses;
	local string	currentRadius;

	local int		currentPosHeights;
	local string	remainingHeights;
	local string	currentHeight;

	currentArrayPosition = 0;

	remainingNames = encodedNames $ ",";
	remainingRadiuses = encodedRadiuses $ ",";
	remainingHeights = encodedHeights $ ",";

	for (i = 0; i < 63; i++) {
		names[i]="None";
		radiuses[i]=0;
		heights[i]=0;
	}

	if (remainingNames == ",")
		return;

	while (instr(remainingNames, ",") != -1) {
		currentPosNames   = instr(remainingNames, ",");
		currentPosRadiuses = instr(remainingRadiuses, ",");
		currentPosHeights = instr(remainingHeights, ",");

		currentName		= left(remainingNames, currentPosNames);
		currentRadius	= left(remainingRadiuses, currentPosRadiuses);
		currentHeight	= left(remainingHeights, currentPosHeights);

		remainingNames	= mid(remainingNames, currentPosNames + 1);
		remainingRadiuses = mid(remainingRadiuses, currentPosRadiuses + 1);
		remainingHeights = mid(remainingHeights, currentPosHeights + 1);

		if (currentPosRadiuses == -1) {
			warn("TO_SPStringDecoder::decodeStrings: Number of elements in strings do not match for '" $ encodedNames $ "' and '" $ encodedRadiuses $ "'.");
			assert(false);
		}

		if (currentPosHeights == -1) {
			warn("TO_SPStringDecoder::decodeStrings: Number of elements in strings do not match for '" $ encodedNames $ "' and '" $ encodedHeights $ "'.");
			assert(false);
		}

		names[currentArrayPosition] = currentName;
		radiuses[currentArrayPosition] = float(currentRadius);
		heights[currentArrayPosition] = float(currentHeight);

		currentArrayPosition++;

		if (currentArrayPosition == 32) {
			warn("TO_SPStringDecoder::decodeStringAndFloats: Too many elements in list: '" $ encodedNames $ "'.");
			assert(false);
		}

	}


}

defaultproperties
{
}
