//=============================================================================
// TO_SP_GUIStory.
//=============================================================================
// Displays the story instead of the server info
//=============================================================================
// Programmed by Mathieu 'EMH_Mark3' Mallet for Tactical Ops
// 02/11/2002
//=============================================================================


class TO_SP_GUIStory expands TO_GUIBaseTab;

var string				TextScreenTitle;
var string				TextScreenParagraph1;
var string				TextScreenParagraph2;
var string				TextScreenParagraph3;
var string				TextScreenParagraph4;
var string				TextScreenParagraph5;

simulated function Created () {
	local TournamentGameReplicationInfo			gri;
	local TO_SinglePlayerGame					game;
	local TO_SinglePlayerDefinition				SPDef;

	Super.Created();
	Title = class'TO_GUITabDebriefing'.default.TextTitle;

	gri = TournamentGameReplicationInfo(OwnerPlayer.GameReplicationInfo);

	game = TO_SinglePlayerGame(GetPlayerOwner().Level.Game);
	if (game == none) {
		if (TO_SP_CutScene(GetPlayerOwner().Level.Game) != none) {
			SPDef = TO_SP_CutScene(GetPlayerOwner().Level.Game).SPDef;
		}
		else {
			TextScreenParagraph1 = "Could not find TO_SinglePlayerGame actor !!";
			return;
		}
	}
	else
		SPDef = game.SinglePlayerDefinition;

	TextScreenTitle =		SPDef.ScenarioName;
	TextScreenParagraph1 =	SPDef.Story1;
	TextScreenParagraph2 =	SPDef.Story2;
	TextScreenParagraph3 =	SPDef.Story3;
	TextScreenParagraph4 =	SPDef.Story4;
	TextScreenParagraph5 =	SPDef.Story5;
}

simulated function Paint (Canvas Canvas, float x, float y) {
	local float									xl, yl, oneline;
	local string								currentText;
	local float									col1, col1l, col2, col2l, pwidth;

	// background
	if (OwnerHud.bDrawBackground) {
		Super.Paint(Canvas, x, y);
	}

	hint = class'TO_GUITabDebriefing'.default.TextHintStory;

	OwnerInterface.Design.SetHeadlineFont(Canvas);
	Canvas.Style = OwnerHud.ERenderStyle.STY_NORMAL;

	y = Top + Padding[Resolution];

	col1 = Left + Padding[resolution];
	col1l = Left + Width / 2 - Padding[resolution];
	col2 = Left + Width / 2 + Padding[resolution];
	col2l = Left + Width - Padding[resolution];

	// Mission title
	currentText = TextScreenTitle;
	Canvas.StrLen(currentText, xl, yl);
	Canvas.DrawColor = OwnerInterface.Design.ColorSuperwhite;
	Canvas.SetPos(Left + Width*0.5 - 0.5*xl, y);
	Canvas.DrawText(currentText);
	y += 2 * yl;

	if (Resolution > 1 )
		y += yl;

	OwnerInterface.Design.SetScoreboardFont(Canvas);

	Canvas.StrLen("abcABC", xl, oneline);

	// Story -- Paragraph 1
	currentText = TextScreenParagraph1;
	Canvas.DrawColor = OwnerInterface.Design.ColorSuperwhite;
	Canvas.SetPos(col1, y);
	Tool_DrawText(Canvas, currentText, col1, y, col2l - col1, xl, yl);
	y += yl;
	
	y += oneline;

	// Story -- Paragraph 2
	if (TextScreenParagraph2 != "") {
		currentText = TextScreenParagraph2;
		Canvas.DrawColor = OwnerInterface.Design.ColorSuperwhite;
		Canvas.SetPos(col1, y);
		Tool_DrawText(Canvas, currentText, col1, y, col2l - col1, xl, yl);
		y += yl;
		
		y += oneline;
	}

	// Story -- Paragraph 3
	if (TextScreenParagraph3 != "") {
		currentText = TextScreenParagraph3;
		Canvas.DrawColor = OwnerInterface.Design.ColorSuperwhite;
		Canvas.SetPos(col1, y);
		Tool_DrawText(Canvas, currentText, col1, y, col2l - col1, xl, yl);
		y += yl;
		
		y += oneline;
	}

	// Story -- Paragraph 4
	if (TextScreenParagraph4 != "") {
		currentText = TextScreenParagraph4;
		Canvas.DrawColor = OwnerInterface.Design.ColorSuperwhite;
		Canvas.SetPos(col1, y);
		Tool_DrawText(Canvas, currentText, col1, y, col2l - col1, xl, yl);
		y += yl;
		
		y += oneline;
	}

	// Story -- Paragraph 5
	if (TextScreenParagraph5 != "") {
		currentText = TextScreenParagraph5;
		Canvas.DrawColor = OwnerInterface.Design.ColorSuperwhite;
		Canvas.SetPos(col1, y);
		Tool_DrawText(Canvas, currentText, col1, y, col2l - col1, xl, yl);
		y += yl;

		y += oneline;
	}

}


simulated function Tool_DrawText (Canvas Canvas, string text, float x, float y, float w, out float xl, out float yl) {
	local float		oldorigx, oldclipx;

	oldorigx = Canvas.OrgX;
	oldclipx = Canvas.ClipX;

	Canvas.OrgX = x;
	Canvas.ClipX = w;

	Canvas.SetPos(0, y);
	Canvas.StrLen(text, xl, yl);
	Canvas.DrawText(text, false);

	Canvas.OrgX = oldorigx;
	Canvas.ClipX = oldclipx;
}

defaultproperties
{
}
