//=============================================================================
// TO_SP_Interpolator.
//=============================================================================
// Sends the player on an interpolated path when triggered
//=============================================================================
// Programmed by Mathieu 'EMH_Mark3' Mallet for Tactical Ops
// 13/10/2002
//=============================================================================

class TO_SP_Interpolator extends SpecialEvent;

state() PlayerPathPlus
{
	function Trigger( actor Other, pawn EventInstigator )
	{
		local InterpolationPoint i;
		Global.Trigger( Self, EventInstigator );
		if( EventInstigator!=None && EventInstigator.bIsPlayer && (Level.NetMode == NM_Standalone) )
		{
			foreach AllActors( class 'InterpolationPoint', i, Event )
			{
				if( i.Position == 0 )
				{
					EventInstigator.GotoState('');
					EventInstigator.SetCollision(True,false,false);
					EventInstigator.bCollideWorld = False;
					EventInstigator.Target = i;
					EventInstigator.SetPhysics(PHYS_Interpolating);
					EventInstigator.PhysRate = 1.0;
					EventInstigator.PhysAlpha = 0.0;
					EventInstigator.bInterpolating = true;
					EventInstigator.AmbientSound = AmbientSound;
					EventInstigator.Health = -1;
				}
			}
		}
	}
}

defaultproperties
{
}
