//=============================================================================
// TO_SP_WaterDrip.
//=============================================================================
// Water drips. Spawned by the TO_SP_WaterSpawner.
//=============================================================================
// Programmed by Mathieu 'EMH_Mark3' Mallet for Tactical Ops
// 24/11/2002
//=============================================================================

class TO_SP_WaterDrip expands Effects;

var sound DripSound;

auto state FallingState {

	function Landed( vector HitNormal ) {
		HitWall(HitNormal, None);	
	}

	simulated function HitWall (vector HitNormal, actor Wall) {
		local splash	aSplash;
		//PlaySound(DripSound);
		aSplash = spawn(class'splash');
		aSplash.DrawScale = 10;
		destroy();
	}
	
	singular function touch(actor Other) {
		local splash		aSplash;
		local waterring		waterring;

		if (Other.IsA('TO_SP_WaterDrip'))
			return;
		
		//PlaySound(DripSound);	
		aSplash = spawn(class'splash');
		aSplash.DrawScale = 7;
		
		if (Other.IsA('TO_SP_WaterSheet') && frand() > 0.5) {
			waterring = spawn(class'WaterRing',,,location + vect(0,0,16),rot(16384,0,0));
			waterring.DrawScale *= 2;
		}

		destroy();
	}

Begin:
	PlayAnim('Dripping',0.3);
}

defaultproperties
{
     DripSound=Sound'UnrealShare.General.Drip1'
     Physics=PHYS_Falling
     LifeSpan=5.000000
     DrawType=DT_Mesh
     Mesh=LodMesh'UnrealShare.dripMesh'
     bCollideWorld=True
}
