//=============================================================================
// TO_SinglePlayerDefinition.
//=============================================================================
// This actor contains all the mission information for a single mission.
// The data is usually copied from the .ini into this file. However, the actor
// can also be added to a map to create a map-specific mission (not supported
// as of now though)
//=============================================================================
// Programmed by Mathieu 'EMH_Mark3' Mallet for Tactical Ops
// 19/08/2002
//=============================================================================

class TO_SinglePlayerDefinition expands TacticalOpsMapActors;

var(SP_Story)		string	Story1;
var(SP_Story)		string	Story2;
var(SP_Story)		string	Story3;
var(SP_Story)		string	Story4;
var(SP_Story)		string	Story5;

var(SP_MissionText)	string	ScenarioName;
var(SP_MissionText)	string	ScenarioDescription1;
var(SP_MissionText)	string	ScenarioDescription2;
var(SP_MissionText)	string	ScenarioText1;
var(SP_MissionText)	string	ScenarioText2;
var(SP_MissionText)	string	ScenarioText3;
var(SP_MissionText)	string	ScenarioText4;
var(SP_MissionText) string	EstimatedEnemyForces;

var(SP_MissionText)	string	AllEnnemiesDeadMSG;
var(SP_MissionText)	string	VIPDeadMSG;
var(SP_MissionText)	string	SpecialTriggersMSG;
var(SP_MissionText)	string	C4ExplodedMSG;
var(SP_MissionText) string	CongradMSG;


var(SP_ScenarioInfo)	int		RoundDuration;
var(SP_ScenarioInfo)	bool	bExterminate;
var(SP_ScenarioInfo)	int		NeededTeamBotsSurvivors;
var(SP_ScenarioInfo)	bool	bNoHostages;

var(SP_PlayerInfo)	int		PlayerTeam;
var(SP_PlayerInfo)	int		PlayerMoney;
var(SP_PlayerInfo)	int		PlayerHealth;
var(SP_PlayerInfo)	string	PlayerSpawnSpot;
var(SP_PlayerInfo)	string	AllowedPlayerWeapons;
var(SP_PlayerInfo)	int		SelfSkin;

var(SP_TeamInfo)	int		TeamBots;
var(SP_TeamInfo)	int		TeamBotsIntelligence;
var(SP_TeamInfo)	int		TeamBotsMoney;
var(SP_TeamInfo)	int		TeamSkins;
var(SP_TeamInfo)	string	TeamBotsGivenWeapons;
var(SP_TeamInfo)	int		TeamBotsHealth;
var(SP_TeamInfo)	TO_SPStringDecoder	TeamBotsNames;

var(SP_InitialEnemies)	int		BotsDifficulty;
var(SP_InitialEnemies)	int		OpposingBots;
var(SP_InitialEnemies)	int		OpposingBotsMoney;
var(SP_InitialEnemies)	TO_SPStringDecoder	OpposingBotsNames;
var(SP_InitialEnemies)	int		OpponentSkins;
var(SP_InitialEnemies)	string	OpposingBotsGivenWeapons;
var(SP_InitialEnemies)	int		OpposingBotsHealth;
var(SP_InitialEnemies)	TO_SPStringDecoder	AdditionnalEnemyBot;
var(SP_InitialEnemies)	int		AdditionnalEnemyBotAttitude;


var(SP_VIP)	string	VIPSpawnSpot;
var(SP_VIP)	string	VIPName;
var(SP_VIP)	int		VIPSkin;
var(SP_VIP)	int		VIPHealth;
var(SP_VIP)	string	VIPGivenWeapons;
var(SP_VIP)	int		VIPDifficulty;
var(SP_VIP)	int		VIPAttitude;

var(SP_SpecialEnemies)	int					bSpawnSpecialEnemy;
var(SP_SpecialEnemies)	TO_SPStringDecoder	SpecialEnemyBot;
var(SP_SpecialEnemies)	string				SpawnSpecialEnemyBotGivenWeapons;
var(SP_SpecialEnemies)	int					SpawnSpecialEnemyBotAttitude;
var(SP_SpecialEnemies)	int					SpawnSpecialEnemyBotHealth;
var(SP_SpecialEnemies)	int					SpawnSpecialEnemyBotSkin;


var(SP_EndGameTriggers)	int					bSpawnEndGameTriggers;
var(SP_EndGameTriggers)	TO_SPStringDecoder	EndGameTriggers;
var(SP_EndGameTriggers) int					ExitRingZOffset;



var(SP_SpecialTriggers)	int					bSpawnSpecialTriggers;
var(SP_SpecialTriggers)	TO_SPStringDecoder	SpecialTriggers;
var(SP_SpecialTriggers)	int					SpawnSpecialTriggersUtility;



var(SP_Special)	string	HardCodedBehaviorsClass;

defaultproperties
{
     bStatic=False
}
