//=============================================================================
// TO_SinglePlayerMaplist.
//=============================================================================
// This actor contains the definition of all the missions used in singlepayer.
// It stores it's date in the file TO_SinglePlayer.ini.
// This actor also have some functions to decode certain saved settings.
//=============================================================================
// Programmed by Mathieu 'EMH_Mark3' Mallet for Tactical Ops
// 19/08/2002
//=============================================================================

class TO_SinglePlayerMaplist expands MapList config(TO_SinglePlayer);

/*enum ETeams
{
	ET_Terrorists,	
	ET_SpecialForces,	
	ET_Both,					
};*/

// NOTE: Arrays can go up to [63] (64 elements)

// Single Player configuration variables
var			config int		BestTime[32];
var			config int		BestTOTeamTime[32];
var			config int		TimeBronze[32];
var			config int		TimeSilver[32];
var			config int		TimeGold[32];
var			config int		CompletedPerfectly[32];
var			config int		CompletedInHardMode[32];
var			config int		CompletedInLudicrousMode[32];
var			config int		EarnedMedal[32];
var			config int		UnlockedCheats[32];
var			config int		SelectedCheats[32];
var			config bool		bPlayingAsTOTeam;
var			config int		lastCompletedMap;
var			config int		playingMode;		// 0 = normal, 1 = hard, 2 = ludicrous
var			config string	ProtagonistName;
var			config int		CutSceneIndex;
var			config int		ModVersionIndex;
var			config int		LastModMission;

var			config int		DebugOptions;
var			config bool		bDisplayMedalTimes;
var			config bool		bDisplayAccuracy;
var			config bool		bUseSimpleEnemyAnalysis;


// Single Player global variables (can be put in default properties once finalised)
var			config int	totalNumberOfMaps;

// Single Player mission variables (can be put in default properties once finalised)
var			config string	Story1[32];
var			config string	Story2[32];
var			config string	Story3[32];
var			config string	Story4[32];
var			config string	Story5[32];

var			config string	MapName[32];
var			config string	ScenarioName[32];
var			config string	ScenarioDescription1[32];
var			config string	ScenarioDescription2[32];
var			config string	ScenarioText1[32];
var			config string	ScenarioText2[32];
var			config string	ScenarioText3[32];
var			config string	ScenarioText4[32];
var			config string	EstimatedEnemyForces[32];

var			config string	AllEnnemiesDeadMSG[32];
var			config string	VIPDeadMSG[32];
var			config string	SpecialTriggersMSG[32];
var			config string	C4ExplodedMSG[32];
var			config string	CongradMSG[32];

var			config int		RoundDuration[32];
var			config int		Exterminate[32];
var			config int		NeededTeamBotsSurvivors[32];
var			config int		NoHostages[32];

var			config int		PlayerTeam[32];
var			config int		PlayerMoney[32];
var			config int		PlayerHealth[32];
var			config string	PlayerSpawnSpot[32];
var			config string	AllowedPlayerWeapons[32];
var			config int		SelfSkin[32];

var			config int		TeamBots[32];
var			config int		TeamBotsIntelligence[32];
var			config int		TeamBotsMoney[32];
var			config int		TeamSkins[32];
var			config string	TeamBotsGivenWeapons[32];
var			config int		TeamBotsHealth[32];
var			config string	TeamBotsSpawnSpots[32];
var			config string	TeamBotsNames[32];

var			config int		BotsDifficulty[32];
var			config int		OpposingBots[32];
var			config int		OpposingBotsMoney[32];
var			config string	OpposingBotsNames[32];
var			config int		OpponentSkins[32];
var			config string	OpposingBotsGivenWeapons[32];
var			config int		OpposingBotsHealth[32];
var			config string	SpawnAdditionnalEnemyBotAt[32];
var			config string	SpawnAdditionnalEnemyBotName[32];
var			config int		AdditionnalEnemyBotAttitude[32];

var			config string	VIPSpawnSpot[32];
var			config string	VIPName[32];
var			config int		VIPSkin[32];
var			config int		VIPHealth[32];
var			config string	VIPGivenWeapons[32];
var			config int		VIPDifficulty[32];
var			config int		VIPAttitude[32];

var			config int		bSpawnSpecialEnemy[32];		// 0 = never, 1 = when all opponents are dead, 2 = when VIP is dead, 3 = when trigger is used, 4 = not used, 5 = when c4 has exploded, 6 = when special actor calls for it
var			config string	SpawnSpecialEnemyBotAt[32];
var			config string	SpawnSpecialEnemyBotName[32];
var			config string	SpawnSpecialEnemyBotGivenWeapons[32];
var			config int		SpawnSpecialEnemyBotAttitude[32];
var			config int		SpawnSpecialEnemyBotHealth[32];
var			config int		SpawnSpecialEnemyBotSkin[32];

var			config int		bSpawnEndGameTriggers[32];	// -1 = never + allow no-win VIP, 0 = never, 1 = when all opponents are dead, 2 = when VIP is dead, 3 = when trigger is used, 4 = at beginning of round, 5 = when c4 has exploded, 6 = when special actor calls for it
var			config string	SpawnEndGameTriggersAt[32];
var			config string	SpawnEndGameTriggersRadius[32];
var			config string	SpawnEndGameTriggersHeight[32];
var			config int		ExitRingZOffset[32];

var			config int		bSpawnSpecialTriggers[32];	// 0 = never, 1 = when all opponents are dead, 2 = when VIP is dead, 3 = not used, 4 = at beginning of round, 5 = when c4 has exploded, 6 = when special actor calls for it
var			config string	SpawnSpecialTriggersAt[32];
var			config string	SpawnSpecialTriggersRadius[32];
var			config string	SpawnSpecialTriggersHeight[32];
var			config int		SpawnSpecialTriggersUtility[32];	// 0 = not used, 1 = spawn special bots, 2 = spawn end game triggers, 3 = invoque TO_SP_HardCodedBehaviors hook 

var			config string	HardCodedBehaviorsClass[32];


// Save the time if it's a new 'record'
function saveBestTime(int time) {
	if (bPlayingAsTOTeam) {
		if (BestTOTeamTime[MapNum] == 0)
			BestTOTeamTime[MapNum] = time;
		else if (time < BestTOTeamTime[MapNum])
			BestTOTeamTime[MapNum] = time;
	}
	else {
		if (BestTime[MapNum] == 0)
			BestTime[MapNum] = time;
		else if (time < BestTime[MapNum])
			BestTime[MapNum] = time;
	}

	SaveConfig();
}

// Returns the best time for that map
function int getBestTime() {
	if (bPlayingAsTOTeam) {
		if (BestTOTeamTime[MapNum] == 0)
			BestTOTeamTime[MapNum] = 817;
		return BestTOTeamTime[MapNum];
	}
	else {
		if (BestTime[MapNum] == 0)
			BestTime[MapNum] = 1200;
		return BestTime[MapNum];
	}
}

// Return the user's best time for the map
function int getUserBestTime() {
	if (BestTime[MapNum] == 0)
		return 1200;
	else
		return BestTime[MapNum];
}

// Return the TO Team's best time for the map
function int getTOTeamBestTime() {
	if (BestTOTeamTime[MapNum] == 0)
		return 1200;
	else
		return BestTOTeamTime[MapNum];
}

// Return the cumulative time for all missions
function int getUserCumulativeTime() {
	local int i, count;

	for (i = 0; i < totalNumberOfMaps; i++) {
		if (BestTime[i] == 0)
			count += 1200;
		else
			count += BestTime[i];
	}

	return count;
}

// Return the cumulative time for all missions
function int getTOTeamCumulativeTime() {
	local int i, count;

	for (i = 0; i < totalNumberOfMaps; i++) {
		if (BestTOTeamTime[i] == 0)
			count += 1200;
		else
			count += BestTOTeamTime[i];
	}

	return count;
}

// Returns true if the cumulative scores should be shown
function bool ShouldDisplayCumulatives() {
	if (totalNumberOfMaps == GetLastCompletedMap())
		return true;
	else
		return false;
}

// Returns true if all maps have been completed
function bool AllMapsCompleted() {
	if (totalNumberOfMaps == GetLastCompletedMap())
		return true;
	else
		return false;
}

// Returns true if the specified map has received a perfect score
function bool IsPerfect(int MapNumber) {
	//log("TO_Maplist::IsPerfect: CompletedPerfectly[MapNumber] = " $ CompletedPerfectly[MapNumber] $ ", % 193 = " $ CompletedPerfectly[MapNumber] % 193 $ ", other side = " $ (192 - MapNumber * 3));
	if ( CompletedPerfectly[MapNumber] % 193 == (192 - MapNumber * 3) )
		return true;
	else
		return false;
}

// Sets the current map as having received a perfect score
function SetCurrentAsPerfect() {
	SetAsPerfect(MapNum);
}

// Sets the specified map as having received a perfect score
function SetAsPerfect(int MapNumber) {
	CompletedPerfectly[MapNumber] = int(frand() * 47) * 193 + (192 - MapNumber * 3);
	SaveConfig();
}




// Returns true if the specified map has been completed in hard mode
function bool IsCompletedInHardMode(int MapNumber) {
	if ( CompletedInHardMode[MapNumber] % 197 == (193 - MapNumber * 3) )
		return true;
	else
		return false;
}

// Sets the current map as completed in hard mode
function SetCurrentAsCompletedInHardMode() {
	SetAsCompletedInHardMode(MapNum);
}

// Sets the specified map as completed in hard mode
function SetAsCompletedInHardMode(int MapNumber) {
	CompletedInHardMode[MapNumber] = int(frand() * 43) * 197 + (193 - MapNumber * 3);
	SaveConfig();
}


// Returns true if the specified map has been completed in Ludicrous mode
function bool IsCompletedInLudicrousMode(int MapNumber) {
	if ( CompletedInLudicrousMode[MapNumber] % 199 == (193 - MapNumber * 3) )
		return true;
	else
		return false;
}

// Sets the current map as completed in Ludicrous mode
function SetCurrentAsCompletedInLudicrousMode() {
	SetAsCompletedInLudicrousMode(MapNum);
}

// Sets the specified map as completed in Ludicrous mode
function SetAsCompletedInLudicrousMode(int MapNumber) {
	CompletedInLudicrousMode[MapNumber] = int(frand() * 43) * 199 + (193 - MapNumber * 3);
	SaveConfig();
}


// Returns true if all maps have been completed in hard mode
function bool CompletedGameInHardMode() {
	local int	i;

	for (i = 0; i < totalNumberOfMaps; i++)
		if (!IsCompletedInHardMode(i))
			return false;

	return true;
}

// Sets the play mode of the current mission.
function bool SetPlayMode(int Mode) {
	playingMode = Mode;
	SaveConfig();
}

// This function puts all user data to 0. Does not affect kamehan times.
function ResetUserData() {
	local int i;

	for (i = 0; i < totalNumberOfMaps; i++) {
		BestTime[i] = 0;
		CompletedPerfectly[i] = 0;
		CompletedInHardMode[i] = 0;
		EarnedMedal[i] = 0;
	}

	for (i = 0; i < 32; i++) {
		UnlockedCheats[i] = 0;
		SelectedCheats[i] = 0;
	}

	playingMode = 0;
	SetLastCompletedMap(0);
	MapNum = 0;

	SaveConfig();
}

// This function returns the times required to get specific medals
function GetMedalTimes(out int bronze, out int silver, out int gold) {
	bronze = TimeBronze[MapNum];
	silver = TimeSilver[MapNum];
	gold = TimeGold[MapNum];
	return;
}

function SaveMedal(int MedalNumber) {
	warn("Save medal function called.");
	
	if (GetMedal(MapNum) <= MedalNumber && EarnedMedal[MapNum] != 0)
		return;

	if (MedalNumber == 0)
		EarnedMedal[MapNum] = 0;
	else
		EarnedMedal[MapNum] = int(frand() * 47) * 193 + (192 - MapNum - MedalNumber * 22);
	
	SaveConfig();
}

function int GetMedal(int MapNumber) {
	//log("Testing medal for "$MapNumber$" modulo = " $ EarnedMedal[MapNumber] % 193 $ " 1: " $ (192 - MapNumber - 1 * 22) $ " 2: " $ (192 - MapNumber - 2 * 22) $ " 3: " $ (192 - MapNumber - 3 * 22));
	//log("TO_Maplist::GetMedal: CompletedPerfectly[MapNumber] = " $ CompletedPerfectly[MapNumber] $ ", % 193 = " $ CompletedPerfectly[MapNumber] % 193 $ ", other side = " $ (192 - MapNumber * 3));
	if (MapNumber > GetLastCompletedMap() || MapNumber > totalNumberOfMaps - 1)
		return 0;
	else if ( EarnedMedal[MapNumber] % 193 == (192 - MapNumber - 1 * 22) )
		return 1;
	else if ( EarnedMedal[MapNumber] % 193 == (192 - MapNumber - 2 * 22) )
		return 2;
	else if ( EarnedMedal[MapNumber] % 193 == (192 - MapNumber - 3 * 22) )
		return 3;
	else
		return 0;
}

function bool CheckDebugOption(int DebugNumber) {
	if ((DebugOptions & DebugNumber) == 0)
		return false;
	else
		return true;
}

function bool IsLastModMap(bool bPlayingInRetailVersion) {
	if (bPlayingInRetailVersion)
		return false;
	else if (MapNum == LastModMission)
		return true;
	else
		return false;
}

// Get the last completed map
function int GetLastCompletedMap() {
	local int temp;
	temp = ((lastCompletedMap ^ -11490) / 127) - 31;
	if (temp < 0 || temp > 31)
		return 0;
	else
		return min(temp, totalNumberOfMaps);
}

// Save the last completed map a specific map
function SetLastCompletedMap(int lastMap) {
	lastCompletedMap = ((lastMap + 31) * 127) ^ -11490;
	SaveConfig();
}

// Increment the last completed map value
function IncrementLastCompletedMap() {
	SetLastCompletedMap(GetLastCompletedMap() + 1);
}



// Checks if a specific cheat is unlocked
function bool IsAnUnlockedCheat(int MapNumber) {
	if ( UnlockedCheats[MapNumber] % 195 == (193 - MapNumber * 3) )
		return true;
	else
		return false;
}

// Sets the specified cheat as either locked or unlocked
function bool SetUnlockedCheatNoSave(int CheatNumber, bool bUnlock) {
	if (bUnlock)
		UnlockedCheats[CheatNumber] = int(frand() * 43) * 195 + (193 - CheatNumber * 3);
	else
		UnlockedCheats[CheatNumber] = 0;

	SelectedCheats[CheatNumber] = 0;

	return bUnlock;
}

// Sets the specified cheat as either locked or unlocked and saves the .ini
function bool SetUnlockedCheat(int MapNumber, bool bUnlock) {
	local bool result;
	result = SetUnlockedCheatNoSave(MapNumber, bUnlock);
	SaveConfig();
	return result;
}


// Check if there is any unlocked cheats
function bool HasAnUnlockedCheat() {
	local int	i;
	for (i = 0; i < 32; i++)
		if (IsAnUnlockedCheat(i))
			return true;

	return false;
}


