//=============================================================================
// TO_SinglePlayerMutator.
//=============================================================================
// Custom functions for singleplayer mutators.
//=============================================================================
// Programmed by Mathieu 'EMH_Mark3' Mallet for Tactical Ops
// 08/12/2002
//=============================================================================

class TO_SinglePlayerMutator expands Mutator;

var bool	bFirstCall;
var TO_SinglePlayerGame		game;

function bool HandleRestartGame() {
	if (bFirstCall) {
		bFirstCall = false;
		game = TO_SinglePlayerGame(Level.Game);
		Initialise();
	}

	PostRestartRound();

	if ( NextMutator != None )
		return NextMutator.HandleRestartGame();
	return false;
}

function Initialise() { }

function PostRestartRound() { }

function EndPreRound() { }

function PlayedBuyedStuff(s_player P) { }

// Give a weapon to a player and optionally bring it up as current weapon.
// Code source: http://wiki.beyondunreal.com/wiki/Useful_Mutator_Functions
function Weapon GiveWeapon(Pawn PlayerPawn, string aClassName, optional bool bBringUp)
{
    local class<Weapon> WeaponClass;
    local Weapon NewWeapon;

    WeaponClass = class<Weapon>(DynamicLoadObject(aClassName, class'Class'));

    if ( PlayerPawn.FindInventoryType(WeaponClass) != None )
        return None;
    newWeapon = Spawn(WeaponClass);
    if ( newWeapon != None ) {
        newWeapon.RespawnTime = 0.0;
        newWeapon.GiveTo(PlayerPawn);
        newWeapon.bHeldItem = true;
        newWeapon.GiveAmmo(PlayerPawn);
        newWeapon.SetSwitchPriority(PlayerPawn);
        newWeapon.WeaponSet(PlayerPawn);
        newWeapon.AmbientGlow = 0;
        if ( PlayerPawn.IsA('PlayerPawn') )
            newWeapon.SetHand(PlayerPawn(PlayerPawn).Handedness);
        else
            newWeapon.GotoState('Idle');
        if ( bBringUp ) {
            PlayerPawn.Weapon.GotoState('DownWeapon');
            PlayerPawn.PendingWeapon = None;
            PlayerPawn.Weapon = newWeapon;
            PlayerPawn.Weapon.BringUp();
        }
    }
    return newWeapon;
}

defaultproperties
{
     bFirstCall=True
}
