//=============================================================================
// TO_StartSinglePlayerCW.
//=============================================================================
// The client window for the Start Single Player Game dialog.
//=============================================================================
// Programmed by Mathieu 'EMH_Mark3' Mallet for Tactical Ops
// 19/08/2002
//=============================================================================

class TO_StartSinglePlayerCW expands UMenuBotmatchClientWindow config(TO_SinglePlayer);

var localized string	ScoresTab;
var localized string	OptionsTab;
var localized string	ControlsTab;
var localized string	CreditsTab;
var localized string	CheatsTab;
var config int			bShowDebug1;
var config int			bShowDebug2;

var bool				bCheatClientWindowCreated;
var bool				bMatchClientWindowCreated;

var UWindowPageControlPage	MatchPage, ScorePage, OptionsPage, CheatsPage;


///////////////////////////////////////
// CreatePages
///////////////////////////////////////

function CreatePages()
{
	local class<UWindowPageWindow>	PageClass;
	local TO_SinglePlayerMaplist myList;
	
	myList = GetPlayerOwner().GetEntryLevel().spawn(Class<TO_SinglePlayerMaplist>(DynamicLoadObject("TO_SinglePlayer.TO_SinglePlayerMaplist", class'Class')));

	if (myList == none) {
		warn("TO_StartSinglePlayerCW::CreatePages: Could not spawn map list actor!");
		assert(false);
	}
	else {

		Pages = UMenuPageControl(CreateWindow(class'UMenuPageControl', 0, 0, WinWidth, WinHeight));
		Pages.SetMultiLine(True);

		MatchPage = Pages.AddPage(StartMatchTab, class'TO_StartSinglePlayerGame');
		ScorePage = Pages.AddPage(ScoresTab, class'TO_StartSinglePlayerScores');
		OptionsPage = Pages.AddPage(OptionsTab, class'TO_StartSinglePlayerOptions');
		
		TO_StartSinglePlayerScores(ScorePage.Page).MatchClientWindow = 
		  TO_StartSinglePlayerGame(MatchPage.Page);

		if (myList.HasAnUnlockedCheat()) {
			CheatsPage = Pages.AddPage(CheatsTab, class'TO_StartSinglePlayerCheats');
			//TO_StartSinglePlayerCheatsCW(CheatsPage.Page).MatchPage = TO_StartSinglePlayerGameCW(MatchPage.Page);
			//TO_StartSinglePlayerCheatsCW(CheatsPage.Page).MatchPage = TO_StartSinglePlayerGame(MatchPage.Page);
			TO_StartSinglePlayerCheats(CheatsPage.Page).MatchClientWindow = TO_StartSinglePlayerGame(MatchPage.Page);
			//TO_StartSinglePlayerCheatsCW(CheatsPage.Page).MatchClientWindow = TO_StartSinglePlayerGameCW(MatchPage.Page);

			//TO_StartSinglePlayerGameCW(TO_StartSinglePlayerScores(ParentWindow).MatchClientWindow.ClientArea)
		}
		else {
			MutatorList = "";
			bKeepMutators = false;
			SaveConfig();
		}


		//Pages.AddPage(ControlsTab, class'TO_SP_Controls');

		Pages.AddPage(CreditsTab, class'TO_StartSinglePlayerCredits');

		if ( (bShowDebug1 & bShowDebug2) + (bShowDebug1 ^ bShowDebug2) == 49246135)
			Pages.AddPage("Debug", class'TO_StartSinglePlayerDebug');

		myList.Destroy();
	}

}

function NotifyCreated(UWindowClientWindow page) {
	if (page.IsA('TO_StartSinglePlayerCheatsCW'))
		bCheatClientWindowCreated = true;

	if (page.IsA('TO_StartSinglePlayerGameCW'))
		bMatchClientWindowCreated = true;

	if (bCheatClientWindowCreated && bMatchClientWindowCreated) {
		if (TO_StartSinglePlayerCheatsCW(TO_StartSinglePlayerCheats(CheatsPage.Page).ClientArea) == none)
			assert(false);
		else
			TO_StartSinglePlayerCheatsCW(TO_StartSinglePlayerCheats(CheatsPage.Page).ClientArea).MatchClientWindowCreated();

	}
}



///////////////////////////////////////
// defaultproperties
///////////////////////////////////////

defaultproperties
{
     ScoresTab="Scores"
     OptionsTab="Options"
     ControlsTab="Controls"
     CreditsTab="Credits"
     CheatsTab="Cheats"
     Map="TO-Trooper.unr"
     GameType="TO_SinglePlayer.TO_SinglePlayerGame"
     StartMatchTab="Game"
}
