//=============================================================================
// TO_StartSinglePlayerDebugCW.
//=============================================================================
// The client window of the Debug tab for the Start Single Player dialog.
//=============================================================================
// Programmed by Mathieu 'EMH_Mark3' Mallet for Tactical Ops
// 19/08/2002
//=============================================================================

//class TO_StartSinglePlayerDebugCW expands UMenuStartMatchClientWindow;
class TO_StartSinglePlayerDebugCW expands UMenuDialogClientWindow;

var bool Initialized;

var UWindowLabelControl		Labels[32];
var UWindowCheckbox			PlayingAsTOTeam;
var UWindowCheckbox			ShowCheatedStatus;		// Bit 1
var UWindowCheckbox			ShowAccuracy;			// Bit 2
var UWindowCheckbox			ShowNormalScoreboard;	// Bit 4

// Last completed map
var	UWindowEditControl		LastCompletedMap;
var UWindowSmallButton		LastCompletedMapButton;

// Cheats
var	UWindowEditControl		CheatNumber;
var UWindowSmallButton		ToggleCheat;
var UWindowSmallButton		UnlockAllCheats;

// Current map
var	UWindowEditControl		CurrentMap;
var UWindowSmallButton		ChangeMapSetting[10];

// Misc buttons
var UWindowSmallButton		MiscButtons[10];

// Message box
var UWindowMessageBox		myMessageBox;
var UWindowMessageBox		msgConfirmResetUserData;




///////////////////////////////////////
// Created
///////////////////////////////////////

function Created()
{
	local int i, j, Pos;

	local int ControlWidth, ControlLeft, ControlRight;
	local int CenterWidth, CenterPos;
	local TO_SinglePlayerMaplist myList;

	Super(UMenuDialogClientWindow).Created();

	DesiredWidth = 270;
	DesiredHeight = 100;

	ControlWidth = WinWidth/2.5;
	ControlLeft = (WinWidth/2 - ControlWidth)/2;
	ControlRight = WinWidth/2 + ControlLeft;

	CenterWidth = (WinWidth/4)*3;
	CenterPos = (WinWidth - CenterWidth)/2;

	//MissionLabel = 	UWindowLabelControl(CreateControl(class'UWindowLabelControl', CenterPos, 10, CenterWidth, 1));
	/*ScoresTitle = 	UWindowLabelControl(CreateControl(class'UWindowLabelControl', 10, 10, 256, 32));
	ScoresTitle.Text = ScoresTitleText;
	ScoresTitle.SetFont(F_Normal);*/

	Pos = 10;

	myList = GetPlayerOwner().GetEntryLevel().spawn(class'TO_SinglePlayerMaplist');

	if (myList != None) {

		Labels[0] = UWindowLabelControl(CreateControl(class'UWindowLabelControl', 10, Pos, 256, 32));
		Labels[0].Text = "Current map (0-based): " $ myList.MapNum;
		Labels[0].SetFont(F_Normal);
		Pos += 15;

		Labels[1] = UWindowLabelControl(CreateControl(class'UWindowLabelControl', 10, Pos, 256, 32));
		Labels[1].Text = "Last completed map (0-based): " $ myList.GetLastCompletedMap();
		Labels[1].SetFont(F_Normal);
		Pos += 15;

		Labels[2] = UWindowLabelControl(CreateControl(class'UWindowLabelControl', 10, Pos, 256, 32));
		Labels[2].Text = "Total number of maps (1-based): " $ myList.totalNumberOfMaps;
		Labels[2].SetFont(F_Normal);
		Pos += 15;

		PlayingAsTOTeam = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 10, Pos, 256, 1));
		if (myList.bPlayingAsTOTeam)
			PlayingAsTOTeam.bChecked = true;
		PlayingAsTOTeam.SetText("bPlayingAsTOTeam");
		PlayingAsTOTeam.SetHelpText("Select to save scores as TO Team scores");
		PlayingAsTOTeam.SetFont(F_Normal);
		//PlayingAsTOTeam.Align = TA_Right;
		Pos += 15;

		// Last completed map control
		LastCompletedMap = UWindowEditControl(CreateControl(class'UWindowEditControl', 10, Pos, 128+32+16, 1));
		LastCompletedMap.SetText("Last completed map (0-based):");
		LastCompletedMap.SetHelpText("Sets the last completed map number. 0-based.");
		LastCompletedMap.SetFont(F_Normal);
		LastCompletedMap.SetNumericOnly(true);
		LastCompletedMap.SetMaxLength(2);
		LastCompletedMap.Align = TA_Left;
		LastCompletedMap.SetValue(string(myList.GetLastCompletedMap()));

		LastCompletedMapButton = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 128+64+16, Pos, 48, 16));
		LastCompletedMapButton.SetText("Save value");
		LastCompletedMapButton.SetFont(F_Normal);
		LastCompletedMapButton.SetHelpText("Click to set the last completed map number. 0-based.");
		Pos += 15;

		// Current map controls
		Pos += 5;
		CurrentMap = UWindowEditControl(CreateControl(class'UWindowEditControl', 10, Pos, 64, 1));
		CurrentMap.SetText("Map: ");
		CurrentMap.SetHelpText("Selects the map # to change settings of (0-based)");
		CurrentMap.SetFont(F_Normal);
		CurrentMap.SetNumericOnly(true);
		CurrentMap.SetMaxLength(2);
		CurrentMap.Align = TA_Left;
		CurrentMap.SetValue(string(myList.MapNum));

		ChangeMapSetting[0] = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 48, Pos, 16, 16));
		ChangeMapSetting[0].SetText("+P");
		ChangeMapSetting[0].SetFont(F_Normal);
		ChangeMapSetting[0].SetHelpText("Set the map as completed perfecly");
		
		ChangeMapSetting[1] = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 48+16, Pos, 16, 16));
		ChangeMapSetting[1].SetText("-P");
		ChangeMapSetting[1].SetFont(F_Normal);
		ChangeMapSetting[1].SetHelpText("Set the map as not completed perfecly");

		ChangeMapSetting[2] = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 48+32, Pos, 16, 16));
		ChangeMapSetting[2].SetText("+H");
		ChangeMapSetting[2].SetFont(F_Normal);
		ChangeMapSetting[2].SetHelpText("Set the map as completed in hard mode");
		
		ChangeMapSetting[3] = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 48+48, Pos, 16, 16));
		ChangeMapSetting[3].SetText("-H");
		ChangeMapSetting[3].SetFont(F_Normal);
		ChangeMapSetting[3].SetHelpText("Set the map as not completed in hard mode");
		
		ChangeMapSetting[4] = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 48+64, Pos, 32, 16));
		ChangeMapSetting[4].SetText("RUT");
		ChangeMapSetting[4].SetFont(F_Normal);
		ChangeMapSetting[4].SetHelpText("Resets the map's user time");
		
		ChangeMapSetting[5] = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 48+96, Pos, 32, 16));
		ChangeMapSetting[5].SetText("RKT");
		ChangeMapSetting[5].SetFont(F_Normal);
		ChangeMapSetting[5].SetHelpText("Resets the map's kamehan time");

		ChangeMapSetting[6] = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 48+96, Pos, 32, 16));
		ChangeMapSetting[6].SetText("RM");
		ChangeMapSetting[6].SetFont(F_Normal);
		ChangeMapSetting[6].SetHelpText("Resets the map's earned medals");

		Pos += 20;

		Pos += 5;
		CheatNumber = UWindowEditControl(CreateControl(class'UWindowEditControl', 10, Pos, 64, 1));
		CheatNumber.SetText("Cheat: ");
		CheatNumber.SetHelpText("A cheat number to lock/unlock");
		CheatNumber.SetFont(F_Normal);
		CheatNumber.SetNumericOnly(true);
		CheatNumber.SetMaxLength(2);
		CheatNumber.Align = TA_Left;
		CheatNumber.SetValue("0");

		ToggleCheat = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 48, Pos, 80, 16));
		ToggleCheat.SetText("Toggle Cheat");
		ToggleCheat.SetFont(F_Normal);
		ToggleCheat.SetHelpText("Lock or unlock the current cheat");

		UnlockAllCheats = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 48+80, Pos, 80, 16));
		UnlockAllCheats.SetText("Unlock All");
		UnlockAllCheats.SetFont(F_Normal);
		UnlockAllCheats.SetHelpText("Unlocks all cheats.");
	
		Pos += 20;

		MiscButtons[0] = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 0, Pos, 128, 16));
		MiscButtons[0].SetText("Import .ini scores");
		MiscButtons[0].SetFont(F_Normal);
		MiscButtons[0].SetHelpText("Import scores from TO_SinglePlayerScoresImporter.ini");

		Pos += 15;
		
		/*MiscButtons[1] = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 0, Pos, 128, 16));
		MiscButtons[1].SetText("Reset user data");
		MiscButtons[1].SetFont(F_Normal);
		MiscButtons[1].SetHelpText("Click to reset last completed map, user scores and accomplishments");

		Pos += 15;*/		

		ShowCheatedStatus = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 10, Pos, 256, 1));
		if (myList.CheckDebugOption(1))
			ShowCheatedStatus.bChecked = true;
		ShowCheatedStatus.SetText("bShowCheatedStatus");
		ShowCheatedStatus.SetHelpText("Select to show if the player cheated on the screen");
		ShowCheatedStatus.SetFont(F_Normal);
		Pos += 15;

		ShowAccuracy = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 10, Pos, 256, 1));
		if (myList.CheckDebugOption(2))
			ShowAccuracy.bChecked = true;
		ShowAccuracy.SetText("bShowAccuracy");
		ShowAccuracy.SetHelpText("Select to show the accuracy on the screen during play");
		ShowAccuracy.SetFont(F_Normal);
		Pos += 15;

		ShowNormalScoreboard = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 10, Pos, 256, 1));
		if (myList.CheckDebugOption(4))
			ShowNormalScoreboard.bChecked = true;
		ShowNormalScoreboard.SetText("bShowNormalScoreboard");
		ShowNormalScoreboard.SetHelpText("Select to show the default TO scoreboard. Useful to debug bot names");
		ShowNormalScoreboard.SetFont(F_Normal);
		Pos += 15;


		myList.Destroy();
	}
	else {
		Labels[0] = UWindowLabelControl(CreateControl(class'UWindowLabelControl', 10, 10, 256, 32));
		Labels[0].Text = "**ERROR**";
		Labels[0].SetFont(F_Normal);
	}

	Initialized = true;
}

 
///////////////////////////////////////
// BeforePaint
///////////////////////////////////////

function BeforePaint(Canvas C, float X, float Y)
{
	Super.BeforePaint(C, X, Y);

	if (!Initialized)
		return;
	
	LastCompletedMap.SetSize(128+32+16, 1);
	LastCompletedMap.WinLeft = 10;
	LastCompletedMap.EditBoxWidth = 25;

	LastCompletedMapButton.AutoWidth(C);
	LastCompletedMapButton.WinLeft = 128+64+16;
	
	CurrentMap.SetSize(64, 1);
	CurrentMap.WinLeft = 10;
	CurrentMap.EditBoxWidth = 32;

	ChangeMapSetting[0].WinLeft = 16+64+16*0;
	ChangeMapSetting[1].WinLeft = 16+64+16*1;
	ChangeMapSetting[2].WinLeft = 16+64+16*2;
	ChangeMapSetting[3].WinLeft = 16+64+16*3;
	ChangeMapSetting[4].WinLeft = 16+64+16*4;
	ChangeMapSetting[5].WinLeft = 16+64+16*6;
	ChangeMapSetting[6].WinLeft = 16+64+16*8;

	CheatNumber.SetSize(64, 1);
	CheatNumber.WinLeft = 10;
	CheatNumber.EditBoxWidth = 32;
	ToggleCheat.WinLeft = 16+64+16*0;
	UnlockAllCheats.WinLeft = 48+80+32;

	MiscButtons[0].WinLeft = 10;
	MiscButtons[1].WinLeft = 10;


}

function Notify(UWindowDialogControl C, byte E)
{
	switch(E)
	{
	case DE_Change:
		switch(C)
		{
		case PlayingAsTOTeam:
			PlayingAsTOTeamChecked();
			break;
		case ShowCheatedStatus:
			ToggleDebugOption(1);
			break;
		case ShowAccuracy:
			ToggleDebugOption(2);
			break;
		case ShowNormalScoreboard:
			ToggleDebugOption(4);
			break;
		/*case LastCompletedMap:
			LastCompletedMapChanged();
			break;*/
		}
		break;

	case DE_Click:
		switch(C)
		{
		case LastCompletedMapButton:
			LastCompletedMapSet();
			break;

		case ChangeMapSetting[0]:
			ChangeMapSettingFunc(0);
			break;
		case ChangeMapSetting[1]:
			ChangeMapSettingFunc(1);
			break;
		case ChangeMapSetting[2]:
			ChangeMapSettingFunc(2);
			break;
		case ChangeMapSetting[3]:
			ChangeMapSettingFunc(3);
			break;
		case ChangeMapSetting[4]:
			ChangeMapSettingFunc(4);
			break;
		case ChangeMapSetting[5]:
			ChangeMapSettingFunc(5);
			break;
		case ChangeMapSetting[6]:
			ChangeMapSettingFunc(6);
			break;
		case ToggleCheat:
			ToggleSelectedCheat();
			break;
		case UnlockAllCheats:
			UnlockAllCheatsFunc();
			break;
		case MiscButtons[0]:
			ImportScores();
			break;
		case MiscButtons[1]:
			ResetUserScores(false);
			break;
		}
		break;

	}

	Super.Notify(C, E);
}

function PlayingAsTOTeamChecked() {
	local TO_SinglePlayerMaplist myList;
	myList = GetPlayerOwner().GetEntryLevel().spawn(class'TO_SinglePlayerMaplist');
	if (myList == none) {
		PlayingAsTOTeam.bChecked = !PlayingAsTOTeam.bChecked;
	}
	else {
		myList.bPlayingAsTOTeam = PlayingAsTOTeam.bChecked;
		myList.SaveConfig();
		myList.Destroy();
	}
}

function ToggleDebugOption(int DebugOption) {
	local TO_SinglePlayerMaplist myList;
	myList = GetPlayerOwner().GetEntryLevel().spawn(class'TO_SinglePlayerMaplist');
	if (myList == none) {
		warn("Could not spawn TO_SinglePlayerMaplist actor!");
		assert(false);
	}
	else {
		myList.DebugOptions = myList.DebugOptions ^ DebugOption;
		myList.SaveConfig();
		myList.Destroy();
	}	
}

function ToggleSelectedCheat() {
	local TO_SinglePlayerMaplist myList;
	myList = GetPlayerOwner().GetEntryLevel().spawn(class'TO_SinglePlayerMaplist');
	if (myList == none) {
		warn("Could not spawn TO_SinglePlayerMaplist actor!");
		assert(false);
	}
	else {
		if (myList.IsAnUnlockedCheat(int(CheatNumber.GetValue())))
			myList.SetUnlockedCheat(int(CheatNumber.GetValue()), false);
		else
			myList.SetUnlockedCheat(int(CheatNumber.GetValue()), true);
		myList.SaveConfig();
		myList.Destroy();
	}	
}

function UnlockAllCheatsFunc() {
	local TO_SinglePlayerMaplist myList;
	local int i;
	myList = GetPlayerOwner().GetEntryLevel().spawn(class'TO_SinglePlayerMaplist');
	if (myList == none) {
		warn("Could not spawn TO_SinglePlayerMaplist actor!");
		assert(false);
	}
	else {
		for (i = 0; i < 32; i++)
			myList.SetUnlockedCheatNoSave(i, true);

		myList.SaveConfig();
		myList.Destroy();
	}	
}

function LastCompletedMapSet() {
	local TO_SinglePlayerMaplist	myList;
	local int						newLastMap;
	myList = GetPlayerOwner().GetEntryLevel().spawn(class'TO_SinglePlayerMaplist');
	if (myList == none) {
		LastCompletedMap.SetValue("99");
	}
	else {
		newLastMap = int(LastCompletedMap.GetValue());
		if (newLastMap <= myList.totalNumberOfMaps - 1 || newLastMap >= 0) {
			myList.SetLastCompletedMap(newLastMap);
			myList.SaveConfig();
			myList.Destroy();
			UWindowFramedWindow(GetParent(class'UWindowFramedWindow')).Close();
		}
		else {
			LastCompletedMap.SetValue(string(myList.GetLastCompletedMap()));
			myList.Destroy();
		}
	}
}

function bool IsValidMapNum(int MapNumber) {
	local TO_SinglePlayerMaplist	myList;

	myList = GetPlayerOwner().GetEntryLevel().spawn(class'TO_SinglePlayerMaplist');
	if (myList != none) {
		if (MapNumber >= 0 || MapNumber <= myList.totalNumberOfMaps - 1) {
			myList.Destroy();
			return true;
		}
		else
			myList.Destroy();
	}

	return false;
}

function ChangeMapSettingFunc(int SettingNum) {
	local int MapNum;
	local TO_SinglePlayerMaplist	myList;

	MapNum = int(CurrentMap.GetValue());
	if (!IsValidMapNum(MapNum)) {
		CurrentMap.SetValue("99");
		return;
	}
	myList = GetPlayerOwner().GetEntryLevel().spawn(class'TO_SinglePlayerMaplist');
	if (myList == none) {
		CurrentMap.SetValue("99");
	}
	else {
		switch (SettingNum) {
		case 0:	// +P
			myList.SetAsPerfect(MapNum);
			break;
		case 1:	// -P
			myList.CompletedPerfectly[MapNum] = 0;
			break;
		case 2:	// +H
			myList.SetAsCompletedInHardMode(MapNum);
			break;
		case 3:	// -H
			myList.CompletedInHardMode[MapNum] = 0;
			break;
		case 5:	// reset kamehan score
			myList.BestTOTeamTime[MapNum] = 0;
			break;
		case 6:	// reset earned medals
			myList.EarnedMedal[MapNum] = 0;
			break;
		}
		myList.SaveConfig();		
		myList.Destroy();
	}
}

function ImportScores() {
	local TO_SinglePlayerScoresImporter myOtherList;
	local int importedscores;
	local string message;

	myOtherList = GetPlayerOwner().GetEntryLevel().spawn(class'TO_SinglePlayerScoresImporter');
	if (myOtherList != none) {
		importedscores = myOtherList.ImportScores();
		message = "Import completed. " $ importedscores $ " scores updated.";
		myMessageBox = MessageBox("TO Team scores importer", message, MB_OK, MR_OK, MR_OK);
		myOtherList.Destroy();
	}

}

function ResetUserScores(bool bConfirmed) {
	local TO_SinglePlayerMaplist	myList;
	if (!bConfirmed) {
		msgConfirmResetUserData = MessageBox("Reset user data",
		 "WARNING: Are you sure you want to delete all user data?",
		 MB_YesNo, MR_No, MR_Yes);
	}
	else {
		myList = GetPlayerOwner().GetEntryLevel().spawn(class'TO_SinglePlayerMaplist');
		if (myList != none) {
			myList.ResetUserData();
			myList.destroy();
			myMessageBox = MessageBox("Reset user data", "User data successfully deleted.", MB_OK, MR_OK, MR_OK);
			UWindowFramedWindow(GetParent(class'UWindowFramedWindow')).Close();
		}
	}
}

function MessageBoxDone(UWindowMessageBox W, MessageBoxResult Result) {
	if (W == msgConfirmResetUserData && Result == MR_Yes)
		ResetUserScores(true);
}


///////////////////////////////////////
// defaultproperties
///////////////////////////////////////

defaultproperties
{
}
