//=============================================================================
// TO_StartSinglePlayerGameCW.
//=============================================================================
// The client window of the Game tab for the Start Single Player dialog.
//=============================================================================
// Programmed by Mathieu 'EMH_Mark3' Mallet for Tactical Ops
// 19/08/2002
//=============================================================================

class TO_StartSinglePlayerGameCW expands UMenuStartMatchClientWindow;

var UWindowCheckbox			ChangeLevelsCheck;
var localized string		ChangeLevelsText;
var localized string		ChangeLevelsHelp;

// Category
var UWindowComboControl		CategoryCombo;
var localized string		CategoryText;
var localized string		CategoryHelp;
var localized string		GeneralText;
var config string			LastCategory;

var UWindowLabelControl		MissionLabel1;
var localized string		MissionLabelText1;
var UWindowLabelControl		MissionLabel2;
var localized string		MissionLabelText2;
var UWindowLabelControl		MissionLabel3;
var localized string		MissionLabelText3;

var UWindowComboControl		PlayMode;
var localized string		PlayModeText;
var localized string		PlayModeHelp;
var localized string		PlayModes[4];
var localized string		EasyModeMessage;
var bool					bCompletedGameInHardMode;

var localized string		ModVersionMessage;
var bool					bDisplayModMessage;

var TO_SP_UWindowLabelControl	CheatingLabel;
var localized string		CheatingLabelText;


var UWindowMessageBox		myMessageBox;


///////////////////////////////////////
// Created
///////////////////////////////////////

function Created()
{
	local int i, j, Selection, BestCategory, CategoryCount, Pos;
	local class<GameInfo> TempClass;
	local string TempGame, NextGame, Package;
	local string TempGames[256];
	local string NextEntry, NextCategory;
	local string Categories[256];
	local bool bFoundSavedGameClass, bAlreadyHave;
	local TO_SinglePlayerMaplist	myList;
	local bool result;

	local int ControlWidth, ControlLeft, ControlRight;
	local int CenterWidth, CenterPos;

	Super(UMenuDialogClientWindow).Created();

	DesiredWidth = 270;
	DesiredHeight = 100;

	ControlWidth = WinWidth/2.5;
	ControlLeft = (WinWidth/2 - ControlWidth)/2;
	ControlRight = WinWidth/2 + ControlLeft;

	CenterWidth = (WinWidth/4)*3;
	CenterPos = (WinWidth - CenterWidth)/2;

	BotmatchParent = UMenuBotmatchClientWindow(GetParent(class'UMenuBotmatchClientWindow'));
	if (BotmatchParent == None)
		warn("Error: UMenuStartMatchClientWindow without UMenuBotmatchClientWindow parent.");

	// Category
	//CategoryCombo = UWindowComboControl(CreateControl(class'UWindowComboControl', CenterPos, 20, CenterWidth, 1));
	CategoryCombo = UWindowComboControl(CreateControl(class'UWindowComboControl', 300, 300, CenterWidth, 1));
	/*CategoryCombo.SetButtons(True);
	CategoryCombo.SetText(CategoryText);
	CategoryCombo.SetHelpText(CategoryHelp);
	CategoryCombo.SetFont(F_Normal);
	CategoryCombo.SetEditable(False);
	CategoryCombo.AddItem(GeneralText);*/

	// Game Type
	//GameCombo = UWindowComboControl(CreateControl(class'UWindowComboControl', CenterPos, 45, CenterWidth, 1));
	GameCombo = UWindowComboControl(CreateControl(class'UWindowComboControl', 300, 300, CenterWidth, 1));
	/*GameCombo.SetButtons(True);
	GameCombo.SetText(GameText);
	GameCombo.SetHelpText(GameHelp);
	GameCombo.SetFont(F_Normal);
	GameCombo.SetEditable(False);*/

	Games[0] = "TO_SinglePlayer.TO_SinglePlayerGame";
	MaxGames = 0;
	TempClass = Class<GameInfo>(DynamicLoadObject(Games[0], class'Class'));
	GameCombo.AddItem(TempClass.Default.GameName);

	GameCombo.SetSelectedIndex(Selection);	
	BotmatchParent.GameType = Games[Selection];
	BotmatchParent.GameClass = Class<GameInfo>(DynamicLoadObject(BotmatchParent.GameType, class'Class'));
	

	// Map
	MapCombo = UWindowComboControl(CreateControl(class'UWindowComboControl', CenterPos, 60, CenterWidth, 1));
	MapCombo.SetButtons(True);
	//MapCombo.SetText(MapText);
	MapCombo.SetText("");
	MapCombo.SetHelpText(MapHelp);
	MapCombo.SetFont(F_Normal);
	MapCombo.SetEditable(False);

	IterateMaps(BotmatchParent.Map);

	// Mission label
	//MissionLabel = 	UWindowLabelControl(CreateControl(class'UWindowLabelControl', CenterPos, 10, CenterWidth, 1));
	MissionLabel1 = 	UWindowLabelControl(CreateControl(class'UWindowLabelControl', 10, 10, 256, 32));
	MissionLabel1.Text = MissionLabelText1;
	MissionLabel1.SetFont(F_Normal);
	MissionLabel2 = 	UWindowLabelControl(CreateControl(class'UWindowLabelControl', 10, 25, 256, 32));
	MissionLabel2.Text = MissionLabelText2;
	MissionLabel2.SetFont(F_Normal);
	MissionLabel3 = 	UWindowLabelControl(CreateControl(class'UWindowLabelControl', 10, 40, 256, 32));
	MissionLabel3.Text = MissionLabelText3;
	MissionLabel3.SetFont(F_Normal);

	
	// Map List Button
	//MapListButton = UWindowSmallButton(CreateControl(class'UWindowSmallButton', CenterPos, 95, 48, 16));
	MapListButton = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 300, 300, 48, 16));
	/*MapListButton.SetText(MapListText);
	MapListButton.SetFont(F_Normal);
	MapListButton.SetHelpText(MapListHelp);*/

	// Mutator Button
	//MutatorButton = UWindowSmallButton(CreateControl(class'UWindowSmallButton', CenterPos, 120, 48, 16));
	MutatorButton = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 300, 300, 48, 16));
	/*MutatorButton.SetText(MutatorText);
	MutatorButton.SetFont(F_Normal);
	MutatorButton.SetHelpText(MutatorHelp);*/

	ControlWidth = WinWidth/2.5;
	ControlLeft = (WinWidth/2 - ControlWidth)/2;
	ControlRight = WinWidth/2 + ControlLeft;

	CenterWidth = (WinWidth/4)*3;
	CenterPos = (WinWidth - CenterWidth)/2;

	/*ChangeLevelsCheck = UWindowCheckbox(CreateControl(class'UWindowCheckbox', CenterPos, 145, ControlWidth, 1));
	ChangeLevelsCheck.SetText(ChangeLevelsText);
	ChangeLevelsCheck.SetHelpText(ChangeLevelsHelp);
	ChangeLevelsCheck.SetFont(F_Normal);
	ChangeLevelsCheck.Align = TA_Right;

	SetChangeLevels();*/

	myList = GetPlayerOwner().GetEntryLevel().spawn(class'TO_SinglePlayerMaplist');
	if (myList == none) {
		warn("TO_StartSinglePlayerGameCW::Created: Could not spawn maplist actor.");
		assert(false);
	}
	else {
		Pos = 60 + 25;
		
		// Play mode
		PlayMode = UWindowComboControl(CreateControl(class'UWindowComboControl', CenterPos, Pos, CenterWidth, 1));
		PlayMode.SetText(PlayModeText);
		PlayMode.SetHelpText(PlayModeHelp);
		PlayMode.SetFont(F_Normal);
		PlayMode.SetEditable(False);
		if (myList.CompletedGameInHardMode())
			bCompletedGameInHardMode = true;

		PlayMode.AddItem(PlayModes[3], "3");
		PlayMode.AddItem(PlayModes[0], "0");
		if (myList.AllMapsCompleted())
			PlayMode.AddItem(PlayModes[1], "1");
		if (bCompletedGameInHardMode)
			PlayMode.AddItem(PlayModes[2], "2");

		if (myList.playingMode == 1)		// Hard
			PlayMode.SetSelectedIndex(2);
		else if (myList.playingMode == 2 && bCompletedGameInHardMode)	// Ludicrous
			PlayMode.SetSelectedIndex(3);
		else if (myList.playingMode == 3)	// Easy
			PlayMode.SetSelectedIndex(0);
		else								// Normal
			PlayMode.SetSelectedIndex(1);
										
		Pos += 25;


		CheatingLabel = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', 10, Pos, 256, 32));
		CheatingLabel.SetTextColor(class'TO_DesignInfo'.default.ColorDarkred);
		CheatingLabel.SetFont(F_Normal);
		//SetCheatMessageVisibility(class'TO_StartSinglePlayerCW'.default.MutatorList == "");
		result = false;
		for (i = 0; i < 32; i++)
			if (myList.SelectedCheats[i] == 1)
				result = true;
		SetCheatMessageVisibility(result);

		Pos += 15;


		myList.Destroy();
	}



	Initialized = true;

	if (TO_RootWindow(Root).bTORetail != true)
		bDisplayModMessage = true;

}

/*function AfterCreate()
{
	Super.AfterCreate();
	GetGameWindow().NotifyCreated(self);
}*/

 
///////////////////////////////////////
// BeforePaint
///////////////////////////////////////

function BeforePaint(Canvas C, float X, float Y)
{
	local int ControlWidth, ControlLeft, ControlRight;
	local int CenterWidth, CenterPos;

	Super.BeforePaint(C, X, Y);

	if (!Initialized)
		return;
	
	ControlWidth = WinWidth/2.5;
	ControlLeft = (WinWidth/2 - ControlWidth)/2;
	ControlRight = WinWidth/2 + ControlLeft;

	CenterWidth = (WinWidth/4)*3;
	CenterPos = (WinWidth - CenterWidth)/2;

	PlayMode.SetSize(CenterWidth, 1);
	PlayMode.WinLeft = CenterPos;
	PlayMode.EditBoxWidth = 90;

	MapCombo.SetSize(CenterWidth, 1);
	MapCombo.WinLeft = CenterPos;
	//MapCombo.EditBoxWidth = 165;
	MapCombo.EditBoxWidth = CenterWidth;

	if (bDisplayModMessage) {
		myMessageBox = MessageBox(GeneralText, ModVersionMessage, MB_OK, MR_OK, MR_OK);
		bDisplayModMessage = false;
	}

}


///////////////////////////////////////
// CategoryChanged
///////////////////////////////////////

function CategoryChanged()
{
	local string CurCategory;
	local int i, Selection, Pos;
	local string NextGame, NextCategory, Package;
	local string TempGames[256];
	local class<GameInfo> TempClass;
	local bool bFoundSavedGameClass;

	if (!Initialized)
		return;

	Initialized = false;

	CurCategory = CategoryCombo.GetValue();
	LastCategory = CurCategory;
	GameCombo.Clear();

	for (i=0; i<256; i++)
		Games[i] = "";
	i=0;

	// Compile a list of all gametypes.
	TempClass = class'TournamentGameInfo';
	GetPlayerOwner().GetNextIntDesc("TournamentGameInfo", 0, NextGame, NextCategory);
	while (NextGame != "")
	{
		if ((CurCategory ~= GeneralText) && (NextCategory == ""))
			TempGames[i] = NextGame;
		else if (NextCategory ~= CurCategory)
			TempGames[i] = NextGame;

		// Hack to Force Tactical Ops only gametypes
		Pos = InStr(NextGame, ".");
		Package = Left(NextGame, Pos);
		//log("Package:"@Package@"NextGame:"@NextGame@"NextCategory:"@NextCategory);
		if (!(Package == "s_SWAT" || Package == "TOUT"))
			TempGames[i] = "";

		i++;
		if(i == 256)
		{
			warn("More than 256 gameinfos listed in int files");
			break;
		}
		GetPlayerOwner().GetNextIntDesc("TournamentGameInfo", i, NextGame, NextCategory);
	}

	// Fill the control.
	for (i=0; i<256; i++)
	{
		if (TempGames[i] != "")
		{
			Games[MaxGames] = TempGames[i];
			if ( !bFoundSavedGameClass && (Games[MaxGames] ~= BotmatchParent.GameType) )
			{
				bFoundSavedGameClass = true;
				Selection = MaxGames;
			}
			TempClass = Class<GameInfo>(DynamicLoadObject(Games[MaxGames], class'Class'));
			GameCombo.AddItem(TempClass.Default.GameName);
			MaxGames++;
		}
	}

	GameCombo.SetSelectedIndex(0);

	Initialized = true;

	GameChanged();

	SaveConfig();
}


///////////////////////////////////////
// GameChanged
///////////////////////////////////////

function GameChanged()
{
	if (!Initialized)
		return;

	Super.GameChanged();
	SetChangeLevels();
}


///////////////////////////////////////
// SetChangeLevels
///////////////////////////////////////

function SetChangeLevels()
{
	local class<DeathMatchPlus> DMP;

	DMP = class<DeathMatchPlus>(BotmatchParent.GameClass);
	if(DMP == None)
	{
		ChangeLevelsCheck.HideWindow();
	}
	else
	{
		ChangeLevelsCheck.ShowWindow();
		ChangeLevelsCheck.bChecked = DMP.default.bChangeLevels;
	}
}


///////////////////////////////////////
// Notify
///////////////////////////////////////

function Notify(UWindowDialogControl C, byte E)
{
	Super.Notify(C, E);

	switch(E)
	{
	case DE_Change:
		switch(C)
		{
		case ChangeLevelsCheck:
			ChangeLevelsChanged();
			break;
		case PlayMode:
			PlayModeChanged();
			break;
		}
		break;
	}
}

function PlayModeChanged() {
	if (Initialized) {
		if (int(PlayMode.GetValue2()) == 3)
			myMessageBox = MessageBox(GeneralText, EasyModeMessage, MB_OK, MR_OK, MR_OK);

		SavePlayMode(int(PlayMode.GetValue2()));
	}
}


///////////////////////////////////////
// ChangeLevelsChanged
///////////////////////////////////////

function ChangeLevelsChanged()
{
	local class<DeathMatchPlus> DMP;

	DMP = class<DeathMatchPlus>(BotmatchParent.GameClass);
	if(DMP != None)
	{
		DMP.default.bChangeLevels = ChangeLevelsCheck.bChecked;
		DMP.static.StaticSaveConfig();
	}
}




///////////////////////////////////////
// ChangeLevelsChanged
///////////////////////////////////////

function IterateMaps(string DefaultMap)
{
	local string FirstMap, NextMap, TestMap;
	local int Selected, currentMap;
	local TO_SinglePlayerMaplist myList;
	local string	MapTitle, tempMissionName, MapName;
	
	myList = GetPlayerOwner().GetEntryLevel().spawn(Class<TO_SinglePlayerMaplist>(DynamicLoadObject("TO_SinglePlayer.TO_SinglePlayerMaplist", class'Class')));

	if (myList == None) {
		warn("TO_StartSinglePlayerGameCW::IterateMaps -- Coult not load TO_SinglePlayerMaplist!!");
		assert(false);
	}
	else
	{
		MapCombo.Clear();
		for (currentMap = 0; currentMap <= myList.GetLastCompletedMap(); currentMap++) {
			if (TO_RootWindow(Root).bTORetail != true && currentMap == 0) {
				if ((myList.GetLastCompletedMap() == 0) || (myList.MapNum == 0)) {
					myList.SetLastCompletedMap(1);
					myList.MapNum = 1;
					myList.SaveConfig();
				}
			}

			NextMap = myList.Maps[currentMap];
			//MapName = myList.MapName[currentMap];
			MapName = myList.ScenarioName[currentMap];
			
			//MapTitle = "Mission " $ (currentMap+1) $ ": " $ Left(NextMap, Len(NextMap) - 4);
			tempMissionName = Left(NextMap, Len(NextMap) - 4);
			
			// Original line: MapTitle = "Mission " $ (currentMap+1) $ ": " $ Right(tempMissionName, Len(tempMissionName) - 3);
			if (MapName ~= "")
				MapTitle = Right(tempMissionName, Len(tempMissionName) - 3);
			else
				MapTitle = MapName;

			//log("Map text: " $ MapTitle $ " -- Map name: " $ NextMap);
			MapCombo.AddItem(MapTitle, NextMap);

			if (currentMap == myList.totalNumberOfMaps - 1)
				break;
		}

		MapCombo.SetSelectedIndex(Min(myList.GetLastCompletedMap(), Max(0, myList.MapNum)));
		myList.MapNum = MapCombo.GetSelectedIndex();
		myList.SaveConfig();
		myList.Destroy();
	}
}


function MapChanged()
{
	local TO_SinglePlayerMaplist myList;
	if (!Initialized)
		return;

	if (MapCombo.GetSelectedIndex() == 0 && TO_RootWindow(Root).bTORetail != true) {
		bDisplayModMessage = true;
		MapCombo.SetSelectedIndex(1);
		return;
	}

	BotmatchParent.Map = MapCombo.GetValue2();
	BotmatchParent.ScreenshotWindow.SetMap(BotmatchParent.Map);

	myList = GetPlayerOwner().GetEntryLevel().spawn(Class<TO_SinglePlayerMaplist>(DynamicLoadObject("TO_SinglePlayer.TO_SinglePlayerMaplist", class'Class')));

	if (myList == None) {
		warn("TO_StartSinglePlayerGameCW::IterateMaps -- Coult not load TO_SinglePlayerMaplist!!");
		assert(false);
	}
	else
	{
		myList.MapNum = MapCombo.GetSelectedIndex();
		//log("Selected Mission #" $ myList.MapNum);
		myList.SaveConfig();
		myList.Destroy();
	}
}

function SelectMission(int mission) {
	MapCombo.SetSelectedIndex(mission);
}

function SavePlayMode(int Mode) {
	local TO_SinglePlayerMaplist myList;
	
	myList = GetPlayerOwner().GetEntryLevel().spawn(Class<TO_SinglePlayerMaplist>(DynamicLoadObject("TO_SinglePlayer.TO_SinglePlayerMaplist", class'Class')));

	if (myList == none) {
		warn("TO_StartSinglePlayerGameCW::SavePlayMode: Could not spawn map list actor!");
		assert(false);
	}
	else {
		myList.SetPlayMode(Mode);
		myList.Destroy();
	}
}

function TO_StartSinglePlayerCW GetGameWindow() {
	return TO_StartSinglePlayerCW(TO_StartSinglePlayerSC(GetParent(class'UWindowFramedWindow')).ClientArea);
}

function SetCheatMessageVisibility(bool bVisible) {
	if (bVisible)
		CheatingLabel.Text = CheatingLabelText;
	else
		CheatingLabel.Text = "";
}


///////////////////////////////////////
// defaultproperties
///////////////////////////////////////

defaultproperties
{
     ChangeLevelsText="Auto Change Levels"
     ChangeLevelsHelp="If this setting is checked, the server will change levels according to the map list for this game type."
     CategoryText="Category:"
     CategoryHelp="Select a category of gametype!"
     GeneralText="Tactical Ops Single Player"
     MissionLabelText1="Select a mission from the list."
     MissionLabelText2="Complete the last mission to get access to the next one."
     PlayModeText="Play mode:"
     PlayModeHelp="Use this to select the difficulty level of the missions."
     PlayModes(0)="Normal"
     PlayModes(1)="Hard"
     PlayModes(2)="Ludicrous"
     PlayModes(3)="Easy"
     EasyModeMessage="Note that by playing in Easy mode, you will not be able to keep track of your scores and medals."
     ModVersionMessage="Since you are using the Mod version of Tactical Ops: Assault on Terror, the training mission is unavailable to you. This means that you will not be able to read the introduction to the story."
     CheatingLabelText="You currently have one or more cheats selected!"
     MapText="Mission:"
}
