//=============================================================================
// TO_StartSinglePlayerOptionsCW.
//=============================================================================
// The client window of the Options tab for the Start Single Player dialog.
//=============================================================================
// Programmed by Mathieu 'EMH_Mark3' Mallet for Tactical Ops
// 27/10/2002
//=============================================================================

//class TO_StartSinglePlayerOptionsCW expands UMenuStartMatchClientWindow;
class TO_StartSinglePlayerOptionsCW expands UMenuDialogClientWindow;

var bool Initialized;

var UWindowLabelControl		Labels[32];

var UWindowCheckbox			DisplayMedalTimes;
var localized string		DisplayMedalTimesText;
var localized string		DisplayMedalTimesHelp;

var UWindowCheckbox			DisplayAccuracy;
var localized string		DisplayAccuracyText;
var localized string		DisplayAccuracyHelp;

var UWindowCheckbox			UseSimpleEnemyAnalysis;
var localized string		UseSimpleEnemyAnalysisText;
var localized string		UseSimpleEnemyAnalysisHelp;

var UWindowSmallButton		ResetGame;
var localized string		ResetGameText;
var localized string		ResetGameHelp;
var UWindowMessageBox		msgConfirmResetGame;
var localized string		ResetGameConfirmTitle;
var localized string		ResetGameConfirmMSG;
var localized string		ResetGameMSG;

var UWindowMessageBox		myMessageBox;

///////////////////////////////////////
// Created
///////////////////////////////////////

function Created()
{
	local int i, j, Pos;

	local int ControlWidth, ControlLeft, ControlRight;
	local int CenterWidth, CenterPos;
	local TO_SinglePlayerMaplist myList;

	Super(UMenuDialogClientWindow).Created();

	DesiredWidth = 270;
	DesiredHeight = 100;

	ControlWidth = WinWidth/2.5;
	ControlLeft = (WinWidth/2 - ControlWidth)/2;
	ControlRight = WinWidth/2 + ControlLeft;

	CenterWidth = (WinWidth/4)*3;
	CenterPos = (WinWidth - CenterWidth)/2;

	Pos = 10;

	myList = GetPlayerOwner().GetEntryLevel().spawn(class'TO_SinglePlayerMaplist');

	if (myList != None) {

		DisplayMedalTimes = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 10, Pos, 256, 1));
		if (myList.bDisplayMedalTimes)
			DisplayMedalTimes.bChecked = true;
		DisplayMedalTimes.SetText(DisplayMedalTimesText);
		DisplayMedalTimes.SetHelpText(DisplayMedalTimesHelp);
		DisplayMedalTimes.SetFont(F_Normal);
		Pos += 15;

		DisplayAccuracy = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 10, Pos, 256, 1));
		if (myList.bDisplayAccuracy)
			DisplayAccuracy.bChecked = true;
		DisplayAccuracy.SetText(DisplayAccuracyText);
		DisplayAccuracy.SetHelpText(DisplayAccuracyHelp);
		DisplayAccuracy.SetFont(F_Normal);
		Pos += 15;

		UseSimpleEnemyAnalysis = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 10, Pos, 256, 1));
		if (myList.bUseSimpleEnemyAnalysis)
			UseSimpleEnemyAnalysis.bChecked = true;
		UseSimpleEnemyAnalysis.SetText(UseSimpleEnemyAnalysisText);
		UseSimpleEnemyAnalysis.SetHelpText(UseSimpleEnemyAnalysisHelp);
		UseSimpleEnemyAnalysis.SetFont(F_Normal);
		Pos += 15;




		ResetGame = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 32, 180, 64, 16));
		ResetGame.SetText(ResetGameText);
		ResetGame.SetFont(F_Normal);
		ResetGame.SetHelpText(ResetGameHelp);
		Pos += 15;

		myList.Destroy();
	}
	else {
		Labels[0] = UWindowLabelControl(CreateControl(class'UWindowLabelControl', 10, 10, 256, 32));
		Labels[0].Text = "**ERROR**";
		Labels[0].SetFont(F_Normal);
	}

	Initialized = true;
}

 
///////////////////////////////////////
// BeforePaint
///////////////////////////////////////

function BeforePaint(Canvas C, float X, float Y)
{
	Super.BeforePaint(C, X, Y);

	if (!Initialized)
		return;

	//ResetGame.WinLeft = WinWidth / 2 - 64 / 2;
	ResetGame.WinLeft = WinWidth - 64 - 10;

}

function Notify(UWindowDialogControl C, byte E)
{
	switch(E)
	{
	case DE_Change:
		switch(C)
		{
		case DisplayMedalTimes:
			DisplayMedalTimesToggle();
			break;
		case DisplayAccuracy:
			DisplayAccuracyToggle();
			break;
		case UseSimpleEnemyAnalysis:
			UseSimpleEnemyAnalysisToggle();
			break;
		}
		break;

	case DE_Click:
		switch(C)
		{
		case ResetGame:
			ResetUserScores(false);
			break;
		}
		break;

	}

	Super.Notify(C, E);
}

function DisplayMedalTimesToggle() {
	local TO_SinglePlayerMaplist myList;
	myList = GetPlayerOwner().GetEntryLevel().spawn(class'TO_SinglePlayerMaplist');
	if (myList == none) {
		DisplayMedalTimes.bChecked = !DisplayMedalTimes.bChecked;
	}
	else {
		myList.bDisplayMedalTimes = DisplayMedalTimes.bChecked;
		myList.SaveConfig();
		myList.Destroy();
	}
}

function DisplayAccuracyToggle() {
	local TO_SinglePlayerMaplist myList;
	myList = GetPlayerOwner().GetEntryLevel().spawn(class'TO_SinglePlayerMaplist');
	if (myList == none) {
		DisplayAccuracy.bChecked = !DisplayAccuracy.bChecked;
	}
	else {
		myList.bDisplayAccuracy = DisplayAccuracy.bChecked;
		myList.SaveConfig();
		myList.Destroy();
	}
}

function UseSimpleEnemyAnalysisToggle() {
	local TO_SinglePlayerMaplist myList;
	myList = GetPlayerOwner().GetEntryLevel().spawn(class'TO_SinglePlayerMaplist');
	if (myList == none) {
		UseSimpleEnemyAnalysis.bChecked = !UseSimpleEnemyAnalysis.bChecked;
	}
	else {
		myList.bUseSimpleEnemyAnalysis = UseSimpleEnemyAnalysis.bChecked;
		myList.SaveConfig();
		myList.Destroy();
	}
}

function ResetUserScores(bool bConfirmed) {
	local TO_SinglePlayerMaplist	myList;
	if (!bConfirmed) {
		msgConfirmResetGame = MessageBox(ResetGameConfirmTitle, ResetGameConfirmMSG, MB_YesNo, MR_No, MR_Yes);
	}
	else {
		myList = GetPlayerOwner().GetEntryLevel().spawn(class'TO_SinglePlayerMaplist');
		if (myList != none) {
			myList.ResetUserData();
			myList.destroy();
			myMessageBox = MessageBox(ResetGameConfirmTitle, ResetGameMSG, MB_OK, MR_OK, MR_OK);
			UWindowFramedWindow(GetParent(class'UWindowFramedWindow')).Close();
		}
	}
}

function MessageBoxDone(UWindowMessageBox W, MessageBoxResult Result) {
	if (W == msgConfirmResetGame && Result == MR_Yes)
		ResetUserScores(true);
}


///////////////////////////////////////
// defaultproperties
///////////////////////////////////////

defaultproperties
{
     DisplayMedalTimesText="Display remaining times for medals"
     DisplayMedalTimesHelp="Enable this to have the times remaining to obtain specific medals be displayed on the screen."
     DisplayAccuracyText="Display accuracy"
     DisplayAccuracyHelp="Enable this to have the accuracy of the shots you take displayed on the screen."
     UseSimpleEnemyAnalysisText="Use simple enemy forces analysis"
     UseSimpleEnemyAnalysisHelp="Enable this to have the exact number of bots in the level displayed on the mission briefing screen."
     ResetGameText="Reset Game"
     ResetGameHelp="Click to reset the game to it's initial state. You will loose all progress you have made so far."
     ResetGameConfirmTitle="TO Single Player: Reset Game"
     ResetGameConfirmMSG="WARNING!  Are you sure you want to erase all game user data, including completed maps, mission times and medals earned?"
     ResetGameMSG="Game user data has been successfully deleted."
}
