//=============================================================================
// TO_StartSinglePlayerScores.
//=============================================================================
// The client window of the Scores tab for the Start Single Player dialog.
//=============================================================================
// Programmed by Mathieu 'EMH_Mark3' Mallet for Tactical Ops
// 19/08/2002
//=============================================================================

class TO_StartSinglePlayerScoresCW expands UMenuPageWindow;
//class TO_StartSinglePlayerScoresCW expands UMenuStartMatchClientWindow;

var bool Initialized;

var TO_SP_UWindowLabelControl	ScoresTitle;

var TO_SP_UWindowLabelControl	HeadMission;
var TO_SP_UWindowLabelControl	HeadUserScores;
var TO_SP_UWindowLabelControl	HeadKamehanScores;

var TO_SP_UWindowLabelControl	Mission[63];
var TO_SP_UWindowLabelControl	UserScores[63];
var TO_SP_UWindowLabelControl	KamehanScores[63];

var TO_SP_UWindowLabelControl	CumMission;
var TO_SP_UWindowLabelControl	CumUserScores[2];
var TO_SP_UWindowLabelControl	CumKamehanScores[2];

var	TO_SP_UWindowLabelControl	Replay1;
var	TO_SP_UWindowLabelControl	Replay2;

var	TO_SP_UWindowLabelControl	Perfect1;
var	TO_SP_UWindowLabelControl	Perfect2;

var	TO_SP_UWindowLabelControl	Hard1;
var	TO_SP_UWindowLabelControl	Hard2;

var	TO_SP_UWindowLabelControl	Ludicrous1;
var	TO_SP_UWindowLabelControl	Ludicrous2;

var string						MissionText;
var bool						bAtLeastOnePerfect;
var bool						bAtLeastOneHard;
var bool						bAtLeastOneLudicrous;

var localized string ScoresTitleText;
var localized string MissionsIncompleteText;
var localized string CumulativeUserScore;
var localized string CumulativeKamehanScore;

var localized string HeadMissionText;
var localized string HeadUserScoresText;
var localized string HeadKamehanScoresText;

var localized string ReplayText1;
var localized string ReplayText2;

var localized string PerfectText1;
var localized string PerfectText2;

var localized string HardText1;
var localized string HardText2;

var localized string LudicrousText1;
var localized string LudicrousText2;

var localized string HardModeChar;
var localized string PerfectChar;

var float	ControlOffset;
var float	ScoresOffset;
var	float	MedalsOffset;
var int		AtLeastOnePerfectOffset;
var int		AtLeastOneHardModeOffset;
var int		AtLeastOneLudicrousModeOffset;

var int		Medals[64];
var int		lastCompletedMap;
var int		bCompletedPerfectly[64];
var int		bCompletedInHardMode[64];





///////////////////////////////////////
// Created
///////////////////////////////////////

function Created()
{
	local int i, j;

	local int Col1, Col2, Col3;
	local TO_SinglePlayerMaplist myList;
	local int UserScore, KamehanScore;
	local int CumUserScoreValue, CumKamehanScoreValue;
	local color BestScoreColor;

	Super(UMenuDialogClientWindow).Created();

	DesiredWidth = 270;
	DesiredHeight = 100;

	Col1 = 10;
	Col2 = 128;
	Col3 = 128+64+16;
	BestScoreColor = class'TO_DesignInfo'.default.ColorDarkred;

	// Mission label
	//MissionLabel = 	UWindowLabelControl(CreateControl(class'UWindowLabelControl', CenterPos, 10, CenterWidth, 1));
	/*MissionLabel1 = 	UWindowLabelControl(CreateControl(class'UWindowLabelControl', 10, 10, 256, 32));
	MissionLabel1.Text = MissionLabelText1;
	MissionLabel1.SetFont(F_Normal);*/

	ControlOffset = 10;

	ScoresTitle = 	TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', Col1, ControlOffset, 256, 32));
	ScoresTitle.Text = ScoresTitleText;
	ScoresTitle.SetFont(F_Normal);

	ControlOffset += 20;

	HeadMission = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', Col1, ControlOffset, 256, 32));
	HeadMission.Text = HeadMissionText;
	HeadMission.SetFont(F_Normal);

	HeadUserScores = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', Col2, ControlOffset, 256, 32));
	HeadUserScores.Text = HeadUserScoresText;
	HeadUserScores.SetFont(F_Normal);

	HeadKamehanScores = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', Col3-16, ControlOffset, 256, 32));
	HeadKamehanScores.Text = HeadKamehanScoresText;
	HeadKamehanScores.SetFont(F_Normal);

	ControlOffset += 20;

	myList = GetPlayerOwner().GetEntryLevel().spawn(class'TO_SinglePlayerMaplist');

	lastCompletedMap = min(myList.GetLastCompletedMap(), myList.totalNumberOfMaps - 1);

	ReadMedalsData();

	ScoresOffset = ControlOffset;

	if (myList != None) {
		
		for (i = 0; i <= lastCompletedMap; i++) {
			Mission[i] = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', Col1, ControlOffset, 256, 32));
			//MissionText = "";
			MissionText = myList.MapName[i];

			if (myList.IsPerfect(i)) {
				bCompletedPerfectly[i] = 1;
				MissionText = PerfectChar $ MissionText;
				bAtLeastOnePerfect = true;
			}
			else
				bCompletedPerfectly[i] = 0;

			if (myList.IsCompletedInHardMode(i)) {
				bCompletedInHardMode[i] = 1;
				MissionText = HardModeChar $ MissionText;
				bAtLeastOneHard = true;
				if (myList.IsCompletedInLudicrousMode(i)) {
					bCompletedInHardMode[i] = -1;
					bAtLeastOneLudicrous = true;
				}
			}
			else
				bCompletedInHardMode[i] = 0;
			
			//if (MissionText == "")
			//	Mission[i].Text = myList.MapName[i];
			//else
			//	Mission[i].Text = MissionText @ myList.MapName[i];
			Mission[i].Text = MissionText;
			Mission[i].SetFont(F_Normal);

			UserScore = myList.BestTime[i];
			KamehanScore = myList.BestTOTeamTime[i];

			UserScores[i] = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', Col2 - MedalsOffset, ControlOffset, 64-16, 32));
			UserScores[i].Text = class'TO_SinglePlayerGame'.static.CalcTextTime(UserScore);
			UserScores[i].SetFont(F_Normal);
			UserScores[i].Align = TA_Right;

			KamehanScores[i] = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', Col3, ControlOffset, 64-16, 32));
			KamehanScores[i].Text = class'TO_SinglePlayerGame'.static.CalcTextTime(KamehanScore);
			KamehanScores[i].SetFont(F_Normal);
			KamehanScores[i].Align = TA_Right;

			if (UserScore <= KamehanScore)
				UserScores[i].SetTextColor(BestScoreColor);
			else
				KamehanScores[i].SetTextColor(BestScoreColor);

			ControlOffset += 15;
		}

		ControlOffset += 5;

		if (myList.ShouldDisplayCumulatives()) {
			// Display cumulative times
			CumUserScoreValue = myList.getUserCumulativeTime();
			CumKamehanScoreValue = myList.getTOTeamCumulativeTime();
			
			CumUserScores[0] = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', Col1, ControlOffset, 256, 32));
			CumUserScores[0].Text = CumulativeUserScore;
			CumUserScores[0].SetFont(F_Normal);

			CumUserScores[1] = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', Col3, ControlOffset, 64-16, 32));
			CumUserScores[1].Text = class'TO_SinglePlayerGame'.static.CalcTextTime(CumUserScoreValue);
			CumUserScores[1].SetFont(F_Normal);
			CumUserScores[1].Align = TA_Right;

			ControlOffset +=15;

			CumKamehanScores[0] = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', Col1, ControlOffset, 256, 32));
			CumKamehanScores[0].Text = CumulativeKamehanScore;
			CumKamehanScores[0].SetFont(F_Normal);

			CumKamehanScores[1] = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', Col3, ControlOffset, 64-16, 32));
			CumKamehanScores[1].Text = class'TO_SinglePlayerGame'.static.CalcTextTime(CumKamehanScoreValue);
			CumKamehanScores[1].SetFont(F_Normal);
			CumKamehanScores[1].Align = TA_Right;

			ControlOffset +=15;

			if (CumUserScoreValue <= CumKamehanScoreValue)
				CumUserScores[1].SetTextColor(BestScoreColor);
			else
				CumKamehanScores[1].SetTextColor(BestScoreColor);
		}
		else {
			// Display incomplete missions text
			CumMission = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', Col1, ControlOffset, 256, 32));
			CumMission.Text = MissionsIncompleteText;
			CumMission.SetFont(F_Normal);
			CumMission.SetTextColor(BestScoreColor);
			ControlOffset +=15;
		}

		ControlOffset += 5;

		Replay1 = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', Col1, ControlOffset, 256, 32));
		Replay1.Text = ReplayText1;
		Replay1.SetFont(F_Normal);
		
		ControlOffset +=15;

		if (ReplayText2 != "") {
			ControlOffset -=5;

			Replay2 = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', Col1, ControlOffset, 256, 32));
			Replay2.Text = ReplayText2;
			Replay2.SetFont(F_Normal);
			
			ControlOffset +=15;
		}

		ControlOffset += 5;

		if (bAtLeastOnePerfect) {
			AtLeastOnePerfectOffset = ControlOffset;
			Perfect1 = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', Col1 + 16, ControlOffset, 256, 32));
			Perfect1.Text = PerfectText1;
			Perfect1.SetFont(F_Normal);
			
			ControlOffset +=15;

			if (PerfectText2 != "") {
				ControlOffset -=5;
				Perfect2 = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', Col1 + 16, ControlOffset, 256, 32));
				Perfect2.Text = PerfectText2;
				Perfect2.SetFont(F_Normal);
				
				ControlOffset +=15;
			}

			ControlOffset += 5;
		}

		if (bAtLeastOneHard) {
			AtLeastOneHardModeOffset = ControlOffset;
			Hard1 = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', Col1 + 16, ControlOffset, 256, 32));
			Hard1.Text = HardText1;
			Hard1.SetFont(F_Normal);
			
			ControlOffset +=15;

			if (HardText2 != "") {
				ControlOffset -=5;
				Hard2 = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', Col1 + 16, ControlOffset, 256, 32));
				Hard2.Text = HardText2;
				Hard2.SetFont(F_Normal);
				
				ControlOffset +=15;
			}
			ControlOffset += 5;
		}

		if (bAtLeastOneLudicrous) {
			AtLeastOneLudicrousModeOffset = ControlOffset;
			Ludicrous1 = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', Col1 + 16, ControlOffset, 256, 32));
			Ludicrous1.Text = LudicrousText1;
			Ludicrous1.SetFont(F_Normal);
			
			ControlOffset +=15;

			if (LudicrousText2 != "") {
				ControlOffset -=5;
				Ludicrous2 = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', Col1 + 16, ControlOffset, 256, 32));
				Ludicrous2.Text = LudicrousText2;
				Ludicrous2.SetFont(F_Normal);
				
				ControlOffset +=15;
			}
			ControlOffset += 5;
		}

		myList.Destroy();
	}
	else {
		Mission[0] = TO_SP_UWindowLabelControl(CreateControl(class'TO_SP_UWindowLabelControl', 10, ControlOffset, 256, 32));
		Mission[0].Text = "Error loading .ini!!!";
		Mission[0].SetFont(F_Normal);
	}

	ControlOffset += 10;
}

function AfterCreate()
{
	Super.AfterCreate();
	DesiredWidth = 270;
	DesiredHeight = ControlOffset;

	Initialized = true;
}

function Paint(Canvas C, float X, float Y)
{
	local int i, Col1, Col2, OffsetFromRight;

	Col1 = 10;
	Col2 = 128 + 32 + 4;
	ControlOffset = ScoresOffset;

	Super.Paint(C, X, Y);

	for (i = 0; i <= lastCompletedMap; i++) {
		OffsetFromRight = Col1;
		if (Medals[i] == 3)
			DrawClippedTexture(C, Col2, ControlOffset, Texture'to_sp_medal_bronze_small');
		else if (Medals[i] == 2)
			DrawClippedTexture(C, Col2, ControlOffset, Texture'to_sp_medal_silver_small');
		else if (Medals[i] == 1)
			DrawClippedTexture(C, Col2, ControlOffset, Texture'to_sp_medal_gold_small');

		if (bCompletedPerfectly[i] == 1) {
			DrawClippedTexture(C, OffsetFromRight, ControlOffset, Texture'to_sp_perfect');
			OffsetFromRight += 16;
		}

		if (bCompletedInHardMode[i] == 1) {
			DrawClippedTexture(C, OffsetFromRight, ControlOffset, Texture'to_sp_hardmode');
			OffsetFromRight += 16;
		}

		if (bCompletedInHardMode[i] == -1) {
			DrawClippedTexture(C, OffsetFromRight, ControlOffset, Texture'to_sp_ludicrous');
			OffsetFromRight += 16;
		}

		ControlOffset += 15;
	}

	if (bAtLeastOnePerfect)
		DrawClippedTexture(C, Col1, AtLeastOnePerfectOffset + 4, Texture'to_sp_perfect');

	if (bAtLeastOneHard)
		DrawClippedTexture(C, Col1, AtLeastOneHardModeOffset + 4, Texture'to_sp_hardmode');

	if (bAtLeastOneLudicrous)
		DrawClippedTexture(C, Col1, AtLeastOneLudicrousModeOffset + 4, Texture'to_sp_ludicrous');
}

function Notify(UWindowDialogControl C, byte E)
{
	local TO_SP_UWindowLabelControl l;
	local int i;
	Super.Notify(C, E);

	switch(E)
	{
	case DE_Click:
		if (C.IsA('TO_SP_UWindowLabelControl'))
			for (i = 0; Mission[i] != None; i++)
				if (TO_SP_UWindowLabelControl(C) == Mission[i])
					SelectMission(i);
		else {
			switch(C)
			{
			case CumMission:
				// Do something?
				break;
			}
		}
		break;
	}
}

// Select a mission from the Match tab
function SelectMission(int mission) {
	// This is a long function used to access the 'match' page and select a new mission.
	TO_StartSinglePlayerGameCW(TO_StartSinglePlayerScores(ParentWindow).MatchClientWindow.ClientArea).SelectMission(mission);
}

function ReadMedalsData() {
	local int i;
	local TO_SinglePlayerMaplist	MyList;

	myList = GetPlayerOwner().GetEntryLevel().spawn(class'TO_SinglePlayerMaplist');

	if (myList == none) {
		warn("TO_StartSinglePlayerScores::ReadMedalsData: Could not spawn maplist actor.");
		assert(false);
	}

	for (i = 0; i <= lastCompletedMap; i++) {
		Medals[i] = myList.GetMedal(i);
		if (Medals[i] != 0)
			MedalsOffset = 16;
	}

	myList.Destroy();
} 

///////////////////////////////////////
// defaultproperties
///////////////////////////////////////

defaultproperties
{
     ScoresTitleText="Your times so far:"
     MissionsIncompleteText="You have not completed all the missions."
     CumulativeUserScore="Your cumulative time:"
     CumulativeKamehanScore="TO Team cumulative time:"
     HeadMissionText="Mission:"
     HeadUserScoresText="Your time"
     HeadKamehanScoresText="TO Team time"
     ReplayText1="To replay a specific mission, click its name and select"
     ReplayText2="start."
     PerfectText1="This symbol denotes a mission in which you"
     PerfectText2="received a perfect score. How many can you get?"
     HardText1="This symbol denotes a mission which you completed"
     HardText2="in 'Hard Mode'."
     HardModeChar="     "
     LudicrousText1="This symbol denotes a mission which you completed"
     LudicrousText2="in 'Ludicrous Mode'."
     PerfectChar="     "
}
